/*===========================================================================*/
/*   (Ast/check_type.scm)                                                    */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/check_type.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;


	BGL_EXPORTED_DECL obj_t
		BGl_z52checkzd2nodezd2typez52zzast_checkzd2typezd2(obj_t, BgL_nodez00_bglt,
		bool_t, bool_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2letzd21311z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2letzd21313z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_za2pairzd2nilza2zd2zztype_cachez00;
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2fail1307zb0zzast_checkzd2typezd2(obj_t, obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2make1319zb0zzast_checkzd2typezd2(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2sync1301zb0zzast_checkzd2typezd2(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzast_checkzd2typezd2();
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_za2foreignza2z00zztype_cachez00;
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static bool_t BGl_za2checkzd2correctnessza2zd2zzast_checkzd2typezd2;
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_checkzd2typezd2();
	BGL_IMPORT obj_t bgl_typeof(obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2sequ1299zb0zzast_checkzd2typezd2(obj_t, obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2boxzd21321z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2boxzd21323z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	static obj_t
		BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(BgL_nodez00_bglt);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_checkzd2typezd2zzast_checkzd2typezd2(obj_t, obj_t,
		bool_t, bool_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2setzd21315z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2clos1297zb0zzast_checkzd2typezd2(obj_t, obj_t);
	static bool_t BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2;
	static obj_t BGl_z62checkzd2typezb0zzast_checkzd2typezd2(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static bool_t BGl_eqtypezf3zf3zzast_checkzd2typezd2(obj_t, obj_t);
	extern bool_t BGl_coercerzd2existszf3z21zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_gczd2rootszd2initz00zzast_checkzd2typezd2();
	static bool_t BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	extern obj_t BGl_za2epairza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2cond1305zb0zzast_checkzd2typezd2(obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2atom1293zb0zzast_checkzd2typezd2(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	static obj_t BGl_requirezd2initializa7ationz75zzast_checkzd2typezd2 = BUNSPEC;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2appzd21325z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2setq1303zb0zzast_checkzd2typezd2(obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_checkzd2typezd2();
	static obj_t
		BGl_z62checkzd2nodezd2typezd2swit1309zb0zzast_checkzd2typezd2(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_checkzd2typezd2();
	static obj_t BGl_z62z52checkzd2nodezd2typez30zzast_checkzd2typezd2(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_za2cellza2z00zztype_cachez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt,
		bool_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_za2pairza2z00zztype_cachez00;
	static obj_t BGl_z62checkzd2nodezd2typez62zzast_checkzd2typezd2(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	static obj_t BGl_z62checkzd2nodezd2type1288z62zzast_checkzd2typezd2(obj_t,
		obj_t);
	static obj_t BGl_errzd2nozd2typez00zzast_checkzd2typezd2(BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2kwot1295zb0zzast_checkzd2typezd2(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_checkzd2typezd2(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_includez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztvector_tvectorz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2func1327zb0zzast_checkzd2typezd2(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t
		BGl_z62checkzd2nodezd2typezd2app1329zb0zzast_checkzd2typezd2(obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2var1291zb0zzast_checkzd2typezd2(obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_checkzd2typezd2();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_checkzd2typezd2();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_checkzd2typezd2();
	extern obj_t BGl_tvecz00zztvector_tvectorz00;
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	extern obj_t BGl_za2compilerzd2typezd2debugzf3za2zf3zzengine_paramz00;
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static bool_t BGl_atomzd2subtypezf3z21zzast_checkzd2typezd2(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_switchz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	static obj_t BGl_errz00zzast_checkzd2typezd2(obj_t, BgL_typez00_bglt, obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t
		BGl_z62checkzd2nodezd2typezd2jump1317zb0zzast_checkzd2typezd2(obj_t, obj_t);
	static obj_t __cnst[3];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2079z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72117za7,
		BGl_z62checkzd2nodezd2type1288z62zzast_checkzd2typezd2, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2081z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72118za7,
		BGl_z62checkzd2nodezd2typezd2var1291zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2083z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72119za7,
		BGl_z62checkzd2nodezd2typezd2atom1293zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2084z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72120za7,
		BGl_z62checkzd2nodezd2typezd2kwot1295zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2085z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72121za7,
		BGl_z62checkzd2nodezd2typezd2clos1297zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2086z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72122za7,
		BGl_z62checkzd2nodezd2typezd2sequ1299zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2087z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72123za7,
		BGl_z62checkzd2nodezd2typezd2sync1301zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2088z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72124za7,
		BGl_z62checkzd2nodezd2typezd2setq1303zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2089z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72125za7,
		BGl_z62checkzd2nodezd2typezd2cond1305zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2090z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72126za7,
		BGl_z62checkzd2nodezd2typezd2fail1307zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2091z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72127za7,
		BGl_z62checkzd2nodezd2typezd2swit1309zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2092z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72128za7,
		BGl_z62checkzd2nodezd2typezd2letzd21311z62zzast_checkzd2typezd2, 0L,
		BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2093z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72129za7,
		BGl_z62checkzd2nodezd2typezd2letzd21313z62zzast_checkzd2typezd2, 0L,
		BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2094z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72130za7,
		BGl_z62checkzd2nodezd2typezd2setzd21315z62zzast_checkzd2typezd2, 0L,
		BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2095z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72131za7,
		BGl_z62checkzd2nodezd2typezd2jump1317zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2096z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72132za7,
		BGl_z62checkzd2nodezd2typezd2make1319zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2097z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72133za7,
		BGl_z62checkzd2nodezd2typezd2boxzd21321z62zzast_checkzd2typezd2, 0L,
		BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2098z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72134za7,
		BGl_z62checkzd2nodezd2typezd2boxzd21323z62zzast_checkzd2typezd2, 0L,
		BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2099z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72135za7,
		BGl_z62checkzd2nodezd2typezd2appzd21325z62zzast_checkzd2typezd2, 0L,
		BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2100z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72136za7,
		BGl_z62checkzd2nodezd2typezd2func1327zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2101z00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72137za7,
		BGl_z62checkzd2nodezd2typezd2app1329zb0zzast_checkzd2typezd2, 0L, BUNSPEC,
		1);
	      DEFINE_STRING(BGl_string2071z00zzast_checkzd2typezd2,
		BgL_bgl_string2071za700za7za7a2138za7, " error", 6);
	      DEFINE_STRING(BGl_string2072z00zzast_checkzd2typezd2,
		BgL_bgl_string2072za700za7za7a2139za7, "s", 1);
	      DEFINE_STRING(BGl_string2073z00zzast_checkzd2typezd2,
		BgL_bgl_string2073za700za7za7a2140za7, "", 0);
	      DEFINE_STRING(BGl_string2074z00zzast_checkzd2typezd2,
		BgL_bgl_string2074za700za7za7a2141za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2075z00zzast_checkzd2typezd2,
		BgL_bgl_string2075za700za7za7a2142za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string2076z00zzast_checkzd2typezd2,
		BgL_bgl_string2076za700za7za7a2143za7, "check-node-type (~a)", 20);
	      DEFINE_STRING(BGl_string2077z00zzast_checkzd2typezd2,
		BgL_bgl_string2077za700za7za7a2144za7,
		"Inconsistent type [~a], \"~a\" expected, \"~a\" provided", 52);
	      DEFINE_STRING(BGl_string2078z00zzast_checkzd2typezd2,
		BgL_bgl_string2078za700za7za7a2145za7, "Untyped node", 12);
	      DEFINE_STRING(BGl_string2080z00zzast_checkzd2typezd2,
		BgL_bgl_string2080za700za7za7a2146za7, "check-node-type1288", 19);
	      DEFINE_STRING(BGl_string2082z00zzast_checkzd2typezd2,
		BgL_bgl_string2082za700za7za7a2147za7, "check-node-type", 15);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_checkzd2typezd2envz00zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2typeza72148za7,
		BGl_z62checkzd2typezb0zzast_checkzd2typezd2, 0L, BUNSPEC, 4);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
		BgL_bgl_za762checkza7d2nodeza72149za7,
		BGl_z62checkzd2nodezd2typez62zzast_checkzd2typezd2, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52checkzd2nodezd2typezd2envz80zzast_checkzd2typezd2,
		BgL_bgl_za762za752checkza7d2no2150za7,
		BGl_z62z52checkzd2nodezd2typez30zzast_checkzd2typezd2, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2102z00zzast_checkzd2typezd2,
		BgL_bgl_string2102za700za7za7a2151za7, " check-full=", 12);
	      DEFINE_STRING(BGl_string2103z00zzast_checkzd2typezd2,
		BgL_bgl_string2103za700za7za7a2152za7, " sub=", 5);
	      DEFINE_STRING(BGl_string2104z00zzast_checkzd2typezd2,
		BgL_bgl_string2104za700za7za7a2153za7, " eq=", 4);
	      DEFINE_STRING(BGl_string2105z00zzast_checkzd2typezd2,
		BgL_bgl_string2105za700za7za7a2154za7, " vtype=", 7);
	      DEFINE_STRING(BGl_string2106z00zzast_checkzd2typezd2,
		BgL_bgl_string2106za700za7za7a2155za7, " type=", 6);
	      DEFINE_STRING(BGl_string2107z00zzast_checkzd2typezd2,
		BgL_bgl_string2107za700za7za7a2156za7, " loc=", 5);
	      DEFINE_STRING(BGl_string2108z00zzast_checkzd2typezd2,
		BgL_bgl_string2108za700za7za7a2157za7, "ERR: ", 5);
	      DEFINE_STRING(BGl_string2109z00zzast_checkzd2typezd2,
		BgL_bgl_string2109za700za7za7a2158za7, ":", 1);
	      DEFINE_STRING(BGl_string2110z00zzast_checkzd2typezd2,
		BgL_bgl_string2110za700za7za7a2159za7, ",", 1);
	      DEFINE_STRING(BGl_string2111z00zzast_checkzd2typezd2,
		BgL_bgl_string2111za700za7za7a2160za7, "Ast/check_type.scm", 18);
	      DEFINE_STRING(BGl_string2112z00zzast_checkzd2typezd2,
		BgL_bgl_string2112za700za7za7a2161za7, "ast_check-type", 14);
	      DEFINE_STRING(BGl_string2113z00zzast_checkzd2typezd2,
		BgL_bgl_string2113za700za7za7a2162za7, "static elight tvector ", 22);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2));
		     ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzast_checkzd2typezd2));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzast_checkzd2typezd2(long
		BgL_checksumz00_2712, char *BgL_fromz00_2713)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_checkzd2typezd2))
				{
					BGl_requirezd2initializa7ationz75zzast_checkzd2typezd2 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_checkzd2typezd2();
					BGl_libraryzd2moduleszd2initz00zzast_checkzd2typezd2();
					BGl_cnstzd2initzd2zzast_checkzd2typezd2();
					BGl_importedzd2moduleszd2initz00zzast_checkzd2typezd2();
					BGl_genericzd2initzd2zzast_checkzd2typezd2();
					BGl_methodzd2initzd2zzast_checkzd2typezd2();
					return BGl_toplevelzd2initzd2zzast_checkzd2typezd2();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_check-type");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_check-type");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0),
				"ast_check-type");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			{	/* Ast/check_type.scm 16 */
				obj_t BgL_cportz00_2543;

				{	/* Ast/check_type.scm 16 */
					obj_t BgL_stringz00_2551;

					BgL_stringz00_2551 = BGl_string2113z00zzast_checkzd2typezd2;
					{	/* Ast/check_type.scm 16 */
						obj_t BgL_startz00_2552;

						BgL_startz00_2552 = BINT(((long) 0));
						{	/* Ast/check_type.scm 16 */
							obj_t BgL_endz00_2553;

							BgL_endz00_2553 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2551)));
							{	/* Ast/check_type.scm 16 */

								BgL_cportz00_2543 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2551, BgL_startz00_2552, BgL_endz00_2553);
				}}}}
				{
					long BgL_iz00_2544;

					BgL_iz00_2544 = ((long) 2);
				BgL_loopz00_2545:
					if ((BgL_iz00_2544 == ((long) -1)))
						{	/* Ast/check_type.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Ast/check_type.scm 16 */
							{	/* Ast/check_type.scm 16 */
								obj_t BgL_arg2115z00_2547;

								{	/* Ast/check_type.scm 16 */

									{	/* Ast/check_type.scm 16 */
										obj_t BgL_locationz00_2549;

										BgL_locationz00_2549 = BBOOL(((bool_t) 0));
										{	/* Ast/check_type.scm 16 */

											BgL_arg2115z00_2547 =
												BGl_readz00zz__readerz00(BgL_cportz00_2543,
												BgL_locationz00_2549);
										}
									}
								}
								{	/* Ast/check_type.scm 16 */
									int BgL_tmpz00_2745;

									BgL_tmpz00_2745 = (int) (BgL_iz00_2544);
									CNST_TABLE_SET(BgL_tmpz00_2745, BgL_arg2115z00_2547);
							}}
							{	/* Ast/check_type.scm 16 */
								int BgL_auxz00_2550;

								BgL_auxz00_2550 = (int) ((BgL_iz00_2544 - ((long) 1)));
								{
									long BgL_iz00_2750;

									BgL_iz00_2750 = (long) (BgL_auxz00_2550);
									BgL_iz00_2544 = BgL_iz00_2750;
									goto BgL_loopz00_2545;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2 = BFALSE;
			BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2 = ((bool_t) 0);
			BGl_za2checkzd2correctnessza2zd2zzast_checkzd2typezd2 = ((bool_t) 0);
			return BUNSPEC;
		}

	}



/* %check-node-type */
	BGL_EXPORTED_DEF obj_t
		BGl_z52checkzd2nodezd2typez52zzast_checkzd2typezd2(obj_t BgL_funz00_25,
		BgL_nodez00_bglt BgL_nodez00_26, bool_t BgL_fullz00_27,
		bool_t BgL_correctnessz00_28)
	{
		{	/* Ast/check_type.scm 41 */
			BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2 = BgL_funz00_25;
			BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2 = BgL_fullz00_27;
			BGl_za2checkzd2correctnessza2zd2zzast_checkzd2typezd2 =
				BgL_correctnessz00_28;
			return BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(BgL_nodez00_26);
		}

	}



/* &%check-node-type */
	obj_t BGl_z62z52checkzd2nodezd2typez30zzast_checkzd2typezd2(obj_t
		BgL_envz00_2467, obj_t BgL_funz00_2468, obj_t BgL_nodez00_2469,
		obj_t BgL_fullz00_2470, obj_t BgL_correctnessz00_2471)
	{
		{	/* Ast/check_type.scm 41 */
			return
				BGl_z52checkzd2nodezd2typez52zzast_checkzd2typezd2(BgL_funz00_2468,
				((BgL_nodez00_bglt) BgL_nodez00_2469),
				CBOOL(BgL_fullz00_2470), CBOOL(BgL_correctnessz00_2471));
		}

	}



/* check-type */
	BGL_EXPORTED_DEF obj_t BGl_checkzd2typezd2zzast_checkzd2typezd2(obj_t
		BgL_passz00_29, obj_t BgL_globalsz00_30, bool_t BgL_fullz00_31,
		bool_t BgL_correctnessz00_32)
	{
		{	/* Ast/check_type.scm 50 */
			if (CBOOL(BGl_za2compilerzd2typezd2debugzf3za2zf3zzengine_paramz00))
				{	/* Ast/check_type.scm 51 */
					BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2 =
						BgL_passz00_29;
					BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2 = BgL_fullz00_31;
					BGl_za2checkzd2correctnessza2zd2zzast_checkzd2typezd2 =
						BgL_correctnessz00_32;
					{
						obj_t BgL_l1270z00_1663;

						BgL_l1270z00_1663 = BgL_globalsz00_30;
					BgL_zc3z04anonymousza31380ze3z87_1664:
						if (PAIRP(BgL_l1270z00_1663))
							{	/* Ast/check_type.scm 55 */
								{	/* Ast/check_type.scm 55 */
									obj_t BgL_arg1406z00_1666;

									BgL_arg1406z00_1666 = CAR(BgL_l1270z00_1663);
									{	/* Ast/check_type.scm 69 */
										BgL_valuez00_bglt BgL_funz00_2344;

										BgL_funz00_2344 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_arg1406z00_1666)))->
											BgL_valuez00);
										{	/* Ast/check_type.scm 69 */
											obj_t BgL_bodyz00_2345;

											BgL_bodyz00_2345 =
												(((BgL_sfunz00_bglt) COBJECT(
														((BgL_sfunz00_bglt) BgL_funz00_2344)))->
												BgL_bodyz00);
											{	/* Ast/check_type.scm 70 */

												BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
													((BgL_nodez00_bglt) BgL_bodyz00_2345));
											}
										}
									}
								}
								{
									obj_t BgL_l1270z00_2769;

									BgL_l1270z00_2769 = CDR(BgL_l1270z00_1663);
									BgL_l1270z00_1663 = BgL_l1270z00_2769;
									goto BgL_zc3z04anonymousza31380ze3z87_1664;
								}
							}
						else
							{	/* Ast/check_type.scm 55 */
								((bool_t) 1);
							}
					}
					if (
						((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
							((long) 0)))
						{	/* Ast/check_type.scm 56 */
							{	/* Ast/check_type.scm 56 */
								obj_t BgL_port1272z00_1671;

								{	/* Ast/check_type.scm 56 */
									obj_t BgL_res2041z00_2352;

									{	/* Ast/check_type.scm 56 */
										obj_t BgL_tmpz00_2774;

										BgL_tmpz00_2774 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2041z00_2352 =
											BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_2774);
									}
									BgL_port1272z00_1671 = BgL_res2041z00_2352;
								}
								bgl_display_obj
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
									BgL_port1272z00_1671);
								bgl_display_string(BGl_string2071z00zzast_checkzd2typezd2,
									BgL_port1272z00_1671);
								{	/* Ast/check_type.scm 56 */
									obj_t BgL_arg1410z00_1672;

									{	/* Ast/check_type.scm 56 */
										bool_t BgL_test2168z00_2779;

										if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Ast/check_type.scm 56 */
												if (INTEGERP
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
													{	/* Ast/check_type.scm 56 */
														BgL_test2168z00_2779 =
															(
															(long)
															CINT
															(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
															> ((long) 1));
													}
												else
													{	/* Ast/check_type.scm 56 */
														BgL_test2168z00_2779 =
															BGl_2ze3ze3zz__r4_numbers_6_5z00
															(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
															BINT(((long) 1)));
											}}
										else
											{	/* Ast/check_type.scm 56 */
												BgL_test2168z00_2779 = ((bool_t) 0);
											}
										if (BgL_test2168z00_2779)
											{	/* Ast/check_type.scm 56 */
												BgL_arg1410z00_1672 =
													BGl_string2072z00zzast_checkzd2typezd2;
											}
										else
											{	/* Ast/check_type.scm 56 */
												BgL_arg1410z00_1672 =
													BGl_string2073z00zzast_checkzd2typezd2;
											}
									}
									bgl_display_obj(BgL_arg1410z00_1672, BgL_port1272z00_1671);
								}
								bgl_display_string(BGl_string2074z00zzast_checkzd2typezd2,
									BgL_port1272z00_1671);
								bgl_display_char(((unsigned char) 10), BgL_port1272z00_1671);
							}
							{	/* Ast/check_type.scm 56 */
								obj_t BgL_list1415z00_1678;

								BgL_list1415z00_1678 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
								return BGl_exitz00zz__errorz00(BgL_list1415z00_1678);
							}
						}
					else
						{	/* Ast/check_type.scm 56 */
							obj_t BgL_g1112z00_1679;

							BgL_g1112z00_1679 = BNIL;
							{
								obj_t BgL_hooksz00_1682;
								obj_t BgL_hnamesz00_1683;

								BgL_hooksz00_1682 = BgL_g1112z00_1679;
								BgL_hnamesz00_1683 = BNIL;
							BgL_zc3z04anonymousza31416ze3z87_1684:
								if (NULLP(BgL_hooksz00_1682))
									{	/* Ast/check_type.scm 56 */
										return BgL_globalsz00_30;
									}
								else
									{	/* Ast/check_type.scm 56 */
										bool_t BgL_test2172z00_2796;

										{	/* Ast/check_type.scm 56 */
											obj_t BgL_fun1430z00_1691;

											BgL_fun1430z00_1691 = CAR(((obj_t) BgL_hooksz00_1682));
											BgL_test2172z00_2796 =
												CBOOL(PROCEDURE_ENTRY(BgL_fun1430z00_1691)
												(BgL_fun1430z00_1691, BEOA));
										}
										if (BgL_test2172z00_2796)
											{	/* Ast/check_type.scm 56 */
												obj_t BgL_arg1421z00_1688;
												obj_t BgL_arg1422z00_1689;

												BgL_arg1421z00_1688 = CDR(((obj_t) BgL_hooksz00_1682));
												BgL_arg1422z00_1689 = CDR(((obj_t) BgL_hnamesz00_1683));
												{
													obj_t BgL_hnamesz00_2808;
													obj_t BgL_hooksz00_2807;

													BgL_hooksz00_2807 = BgL_arg1421z00_1688;
													BgL_hnamesz00_2808 = BgL_arg1422z00_1689;
													BgL_hnamesz00_1683 = BgL_hnamesz00_2808;
													BgL_hooksz00_1682 = BgL_hooksz00_2807;
													goto BgL_zc3z04anonymousza31416ze3z87_1684;
												}
											}
										else
											{	/* Ast/check_type.scm 56 */
												obj_t BgL_arg1429z00_1690;

												BgL_arg1429z00_1690 = CAR(((obj_t) BgL_hnamesz00_1683));
												return
													BGl_internalzd2errorzd2zztools_errorz00
													(BGl_za2currentzd2passza2zd2zzengine_passz00,
													BGl_string2075z00zzast_checkzd2typezd2,
													BgL_arg1429z00_1690);
											}
									}
							}
						}
				}
			else
				{	/* Ast/check_type.scm 51 */
					return BFALSE;
				}
		}

	}



/* &check-type */
	obj_t BGl_z62checkzd2typezb0zzast_checkzd2typezd2(obj_t BgL_envz00_2472,
		obj_t BgL_passz00_2473, obj_t BgL_globalsz00_2474, obj_t BgL_fullz00_2475,
		obj_t BgL_correctnessz00_2476)
	{
		{	/* Ast/check_type.scm 50 */
			return
				BGl_checkzd2typezd2zzast_checkzd2typezd2(BgL_passz00_2473,
				BgL_globalsz00_2474, CBOOL(BgL_fullz00_2475),
				CBOOL(BgL_correctnessz00_2476));
		}

	}



/* err */
	obj_t BGl_errz00zzast_checkzd2typezd2(obj_t BgL_nodez00_34,
		BgL_typez00_bglt BgL_t1z00_35, obj_t BgL_t2z00_36)
	{
		{	/* Ast/check_type.scm 76 */
			{	/* Ast/check_type.scm 77 */
				obj_t BgL_arg1442z00_1696;
				obj_t BgL_arg1457z00_1697;
				obj_t BgL_arg1466z00_1698;
				obj_t BgL_arg1473z00_1699;

				BgL_arg1442z00_1696 =
					(((BgL_nodez00_bglt) COBJECT(
							((BgL_nodez00_bglt) BgL_nodez00_34)))->BgL_locz00);
				{	/* Ast/check_type.scm 78 */
					obj_t BgL_list1476z00_1701;

					BgL_list1476z00_1701 =
						MAKE_YOUNG_PAIR
						(BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2, BNIL);
					BgL_arg1457z00_1697 =
						BGl_formatz00zz__r4_output_6_10_3z00
						(BGl_string2076z00zzast_checkzd2typezd2, BgL_list1476z00_1701);
				}
				{	/* Ast/check_type.scm 79 */
					obj_t BgL_arg1488z00_1702;
					obj_t BgL_arg1490z00_1703;
					obj_t BgL_arg1492z00_1704;

					BgL_arg1488z00_1702 = bgl_typeof(BgL_nodez00_34);
					BgL_arg1490z00_1703 = BGl_shapez00zztools_shapez00(BgL_t2z00_36);
					BgL_arg1492z00_1704 =
						BGl_shapez00zztools_shapez00(((obj_t) BgL_t1z00_35));
					{	/* Ast/check_type.scm 79 */
						obj_t BgL_list1494z00_1705;

						{	/* Ast/check_type.scm 79 */
							obj_t BgL_arg1502z00_1706;

							{	/* Ast/check_type.scm 79 */
								obj_t BgL_arg1503z00_1707;

								BgL_arg1503z00_1707 =
									MAKE_YOUNG_PAIR(BgL_arg1492z00_1704, BNIL);
								BgL_arg1502z00_1706 =
									MAKE_YOUNG_PAIR(BgL_arg1490z00_1703, BgL_arg1503z00_1707);
							}
							BgL_list1494z00_1705 =
								MAKE_YOUNG_PAIR(BgL_arg1488z00_1702, BgL_arg1502z00_1706);
						}
						BgL_arg1466z00_1698 =
							BGl_formatz00zz__r4_output_6_10_3z00
							(BGl_string2077z00zzast_checkzd2typezd2, BgL_list1494z00_1705);
					}
				}
				BgL_arg1473z00_1699 = BGl_shapez00zztools_shapez00(BgL_nodez00_34);
				return
					BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_arg1442z00_1696,
					BgL_arg1457z00_1697, BgL_arg1466z00_1698, BgL_arg1473z00_1699, BNIL);
			}
		}

	}



/* err-no-type */
	obj_t BGl_errzd2nozd2typez00zzast_checkzd2typezd2(BgL_nodez00_bglt
		BgL_nodez00_37)
	{
		{	/* Ast/check_type.scm 85 */
			{	/* Ast/check_type.scm 86 */
				obj_t BgL_arg1510z00_1708;
				obj_t BgL_arg1512z00_1709;
				obj_t BgL_arg1514z00_1710;

				BgL_arg1510z00_1708 =
					(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_37))->BgL_locz00);
				{	/* Ast/check_type.scm 87 */
					obj_t BgL_list1516z00_1712;

					BgL_list1516z00_1712 =
						MAKE_YOUNG_PAIR
						(BGl_za2checkzd2typezd2passza2z00zzast_checkzd2typezd2, BNIL);
					BgL_arg1512z00_1709 =
						BGl_formatz00zz__r4_output_6_10_3z00
						(BGl_string2076z00zzast_checkzd2typezd2, BgL_list1516z00_1712);
				}
				BgL_arg1514z00_1710 =
					BGl_shapez00zztools_shapez00(((obj_t) BgL_nodez00_37));
				return
					BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_arg1510z00_1708,
					BgL_arg1512z00_1709, BGl_string2078z00zzast_checkzd2typezd2,
					BgL_arg1514z00_1710, BNIL);
			}
		}

	}



/* eqtype? */
	bool_t BGl_eqtypezf3zf3zzast_checkzd2typezd2(obj_t BgL_t1z00_60,
		obj_t BgL_t2z00_61)
	{
		{	/* Ast/check_type.scm 319 */
			{	/* Ast/check_type.scm 320 */
				bool_t BgL__ortest_1136z00_1718;

				{	/* Ast/check_type.scm 320 */
					bool_t BgL__ortest_1137z00_1720;

					BgL__ortest_1137z00_1720 = (BgL_t1z00_60 == BgL_t2z00_61);
					if (BgL__ortest_1137z00_1720)
						{	/* Ast/check_type.scm 320 */
							BgL__ortest_1136z00_1718 = BgL__ortest_1137z00_1720;
						}
					else
						{	/* Ast/check_type.scm 320 */
							bool_t BgL__ortest_1138z00_1721;

							BgL__ortest_1138z00_1721 =
								(BgL_t1z00_60 == BGl_za2magicza2z00zztype_cachez00);
							if (BgL__ortest_1138z00_1721)
								{	/* Ast/check_type.scm 320 */
									BgL__ortest_1136z00_1718 = BgL__ortest_1138z00_1721;
								}
							else
								{	/* Ast/check_type.scm 320 */
									BgL__ortest_1136z00_1718 =
										(BgL_t2z00_61 == BGl_za2magicza2z00zztype_cachez00);
								}
						}
				}
				if (BgL__ortest_1136z00_1718)
					{	/* Ast/check_type.scm 320 */
						return BgL__ortest_1136z00_1718;
					}
				else
					{	/* Ast/check_type.scm 320 */
						if ((BgL_t1z00_60 == BGl_za2_za2z00zztype_cachez00))
							{	/* Ast/check_type.scm 321 */
								if (BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2)
									{	/* Ast/check_type.scm 321 */
										return ((bool_t) 0);
									}
								else
									{	/* Ast/check_type.scm 321 */
										return ((bool_t) 1);
									}
							}
						else
							{	/* Ast/check_type.scm 321 */
								return ((bool_t) 0);
							}
					}
			}
		}

	}



/* subtype? */
	bool_t BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_typez00_bglt BgL_t1z00_62,
		BgL_typez00_bglt BgL_t2z00_63)
	{
		{	/* Ast/check_type.scm 328 */
			if ((((obj_t) BgL_t1z00_62) == ((obj_t) BgL_t2z00_63)))
				{	/* Ast/check_type.scm 330 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/check_type.scm 332 */
					bool_t BgL_test2179z00_2848;

					if ((((obj_t) BgL_t2z00_63) == BGl_za2_za2z00zztype_cachez00))
						{	/* Ast/check_type.scm 332 */
							BgL_test2179z00_2848 = ((bool_t) 1);
						}
					else
						{	/* Ast/check_type.scm 332 */
							BgL_test2179z00_2848 =
								(((obj_t) BgL_t1z00_62) == BGl_za2_za2z00zztype_cachez00);
						}
					if (BgL_test2179z00_2848)
						{	/* Ast/check_type.scm 332 */
							if (BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2)
								{	/* Ast/check_type.scm 333 */
									return ((bool_t) 0);
								}
							else
								{	/* Ast/check_type.scm 333 */
									return ((bool_t) 1);
								}
						}
					else
						{	/* Ast/check_type.scm 334 */
							bool_t BgL_test2182z00_2855;

							if (BGl_za2checkzd2correctnessza2zd2zzast_checkzd2typezd2)
								{	/* Ast/check_type.scm 334 */
									BgL_test2182z00_2855 =
										CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00);
								}
							else
								{	/* Ast/check_type.scm 334 */
									BgL_test2182z00_2855 = ((bool_t) 1);
								}
							if (BgL_test2182z00_2855)
								{	/* Ast/check_type.scm 334 */
									return ((bool_t) 1);
								}
							else
								{	/* Ast/check_type.scm 336 */
									bool_t BgL_test2184z00_2858;

									if (
										(((obj_t) BgL_t1z00_62) ==
											BGl_za2magicza2z00zztype_cachez00))
										{	/* Ast/check_type.scm 336 */
											BgL_test2184z00_2858 = ((bool_t) 1);
										}
									else
										{	/* Ast/check_type.scm 336 */
											BgL_test2184z00_2858 =
												(
												((obj_t) BgL_t2z00_63) ==
												BGl_za2magicza2z00zztype_cachez00);
										}
									if (BgL_test2184z00_2858)
										{	/* Ast/check_type.scm 336 */
											return ((bool_t) 1);
										}
									else
										{	/* Ast/check_type.scm 336 */
											if (
												(((obj_t) BgL_t2z00_63) ==
													BGl_za2pairzd2nilza2zd2zztype_cachez00))
												{	/* Ast/check_type.scm 340 */
													bool_t BgL__ortest_1140z00_1729;

													BgL__ortest_1140z00_1729 =
														(
														((obj_t) BgL_t1z00_62) ==
														BGl_za2pairza2z00zztype_cachez00);
													if (BgL__ortest_1140z00_1729)
														{	/* Ast/check_type.scm 340 */
															return BgL__ortest_1140z00_1729;
														}
													else
														{	/* Ast/check_type.scm 340 */
															bool_t BgL__ortest_1141z00_1730;

															BgL__ortest_1141z00_1730 =
																(
																((obj_t) BgL_t1z00_62) ==
																BGl_za2epairza2z00zztype_cachez00);
															if (BgL__ortest_1141z00_1730)
																{	/* Ast/check_type.scm 340 */
																	return BgL__ortest_1141z00_1730;
																}
															else
																{	/* Ast/check_type.scm 340 */
																	return
																		(
																		((obj_t) BgL_t1z00_62) ==
																		BGl_za2bnilza2z00zztype_cachez00);
																}
														}
												}
											else
												{	/* Ast/check_type.scm 341 */
													bool_t BgL_test2189z00_2875;

													if (
														(((obj_t) BgL_t2z00_63) ==
															BGl_za2pairza2z00zztype_cachez00))
														{	/* Ast/check_type.scm 341 */
															BgL_test2189z00_2875 =
																(BGl_za2epairza2z00zztype_cachez00 ==
																((obj_t) BgL_t1z00_62));
														}
													else
														{	/* Ast/check_type.scm 341 */
															BgL_test2189z00_2875 = ((bool_t) 0);
														}
													if (BgL_test2189z00_2875)
														{	/* Ast/check_type.scm 341 */
															return ((bool_t) 1);
														}
													else
														{	/* Ast/check_type.scm 343 */
															bool_t BgL_test2191z00_2881;

															{	/* Ast/check_type.scm 343 */
																bool_t BgL_test2192z00_2882;

																{	/* Ast/check_type.scm 343 */
																	bool_t BgL_res2046z00_2374;

																	BgL_res2046z00_2374 =
																		BGl_isazf3zf3zz__objectz00(
																		((obj_t) BgL_t1z00_62),
																		BGl_tclassz00zzobject_classz00);
																	BgL_test2192z00_2882 = BgL_res2046z00_2374;
																}
																if (BgL_test2192z00_2882)
																	{	/* Ast/check_type.scm 343 */
																		bool_t BgL_res2047z00_2375;

																		BgL_res2047z00_2375 =
																			BGl_isazf3zf3zz__objectz00(
																			((obj_t) BgL_t2z00_63),
																			BGl_tclassz00zzobject_classz00);
																		BgL_test2191z00_2881 = BgL_res2047z00_2375;
																	}
																else
																	{	/* Ast/check_type.scm 343 */
																		BgL_test2191z00_2881 = ((bool_t) 0);
																	}
															}
															if (BgL_test2191z00_2881)
																{	/* Ast/check_type.scm 343 */
																	return
																		BGl_typezd2subclasszf3z21zzobject_classz00
																		(BgL_t1z00_62, BgL_t2z00_63);
																}
															else
																{	/* Ast/check_type.scm 343 */
																	if (
																		(((obj_t) BgL_t2z00_63) ==
																			BGl_za2objza2z00zztype_cachez00))
																		{	/* Ast/check_type.scm 346 */
																			return ((bool_t) 1);
																		}
																	else
																		{	/* Ast/check_type.scm 349 */
																			bool_t BgL_test2194z00_2891;

																			if (
																				(((obj_t) BgL_t2z00_63) ==
																					BGl_za2foreignza2z00zztype_cachez00))
																				{	/* Ast/check_type.scm 349 */
																					BgL_test2194z00_2891 =
																						BGl_coercerzd2existszf3z21zztype_coercionz00
																						(BgL_t1z00_62, BgL_t2z00_63);
																				}
																			else
																				{	/* Ast/check_type.scm 349 */
																					BgL_test2194z00_2891 = ((bool_t) 0);
																				}
																			if (BgL_test2194z00_2891)
																				{	/* Ast/check_type.scm 349 */
																					return ((bool_t) 1);
																				}
																			else
																				{	/* Ast/check_type.scm 352 */
																					bool_t BgL_test2196z00_2896;

																					if (
																						(((obj_t) BgL_t1z00_62) ==
																							BGl_za2foreignza2z00zztype_cachez00))
																						{	/* Ast/check_type.scm 352 */
																							BgL_test2196z00_2896 =
																								BGl_coercerzd2existszf3z21zztype_coercionz00
																								(BgL_t1z00_62, BgL_t2z00_63);
																						}
																					else
																						{	/* Ast/check_type.scm 352 */
																							BgL_test2196z00_2896 =
																								((bool_t) 0);
																						}
																					if (BgL_test2196z00_2896)
																						{	/* Ast/check_type.scm 352 */
																							return ((bool_t) 1);
																						}
																					else
																						{	/* Ast/check_type.scm 352 */
																							if (
																								((((BgL_typez00_bglt)
																											COBJECT(BgL_t1z00_62))->
																										BgL_idz00) ==
																									CNST_TABLE_REF(((long) 0))))
																								{	/* Ast/check_type.scm 355 */
																									bool_t BgL_res2048z00_2377;

																									BgL_res2048z00_2377 =
																										BGl_isazf3zf3zz__objectz00(
																										((obj_t) BgL_t2z00_63),
																										BGl_tvecz00zztvector_tvectorz00);
																									return BgL_res2048z00_2377;
																								}
																							else
																								{	/* Ast/check_type.scm 355 */
																									return ((bool_t) 0);
																								}
																						}
																				}
																		}
																}
														}
												}
										}
								}
						}
				}
		}

	}



/* atom-subtype? */
	bool_t BGl_atomzd2subtypezf3z21zzast_checkzd2typezd2(BgL_typez00_bglt
		BgL_t1z00_64, BgL_typez00_bglt BgL_t2z00_65)
	{
		{	/* Ast/check_type.scm 363 */
			if ((((obj_t) BgL_t1z00_64) == BGl_za2_za2z00zztype_cachez00))
				{	/* Ast/check_type.scm 365 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/check_type.scm 365 */
					if ((((obj_t) BgL_t1z00_64) == ((obj_t) BgL_t2z00_65)))
						{	/* Ast/check_type.scm 367 */
							return ((bool_t) 1);
						}
					else
						{	/* Ast/check_type.scm 369 */
							bool_t BgL_test2201z00_2914;

							if ((((obj_t) BgL_t1z00_64) == BGl_za2longza2z00zztype_cachez00))
								{	/* Ast/check_type.scm 369 */
									BgL_test2201z00_2914 = ((bool_t) 1);
								}
							else
								{	/* Ast/check_type.scm 369 */
									BgL_test2201z00_2914 =
										(((obj_t) BgL_t1z00_64) == BGl_za2intza2z00zztype_cachez00);
								}
							if (BgL_test2201z00_2914)
								{	/* Ast/check_type.scm 370 */
									bool_t BgL__ortest_1142z00_1756;

									BgL__ortest_1142z00_1756 =
										(
										((obj_t) BgL_t2z00_65) == BGl_za2longza2z00zztype_cachez00);
									if (BgL__ortest_1142z00_1756)
										{	/* Ast/check_type.scm 370 */
											return BgL__ortest_1142z00_1756;
										}
									else
										{	/* Ast/check_type.scm 370 */
											return
												(
												((obj_t) BgL_t2z00_65) ==
												BGl_za2intza2z00zztype_cachez00);
										}
								}
							else
								{	/* Ast/check_type.scm 369 */
									return ((bool_t) 0);
								}
						}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_proc2079z00zzast_checkzd2typezd2, BGl_nodez00zzast_nodez00,
				BGl_string2080z00zzast_checkzd2typezd2);
		}

	}



/* &check-node-type1288 */
	obj_t BGl_z62checkzd2nodezd2type1288z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2478, obj_t BgL_nodez00_2479)
	{
		{	/* Ast/check_type.scm 103 */
			{	/* Ast/check_type.scm 104 */
				bool_t BgL_test2204z00_2926;

				if (BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2)
					{	/* Ast/check_type.scm 104 */
						BgL_typez00_bglt BgL_arg1582z00_2557;

						BgL_arg1582z00_2557 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_nodez00_2479)))->BgL_typez00);
						BgL_test2204z00_2926 =
							(((obj_t) BgL_arg1582z00_2557) == BGl_za2_za2z00zztype_cachez00);
					}
				else
					{	/* Ast/check_type.scm 104 */
						BgL_test2204z00_2926 = ((bool_t) 0);
					}
				if (BgL_test2204z00_2926)
					{	/* Ast/check_type.scm 104 */
						return
							BGl_errzd2nozd2typez00zzast_checkzd2typezd2(
							((BgL_nodez00_bglt) BgL_nodez00_2479));
					}
				else
					{	/* Ast/check_type.scm 104 */
						return BFALSE;
					}
			}
		}

	}



/* check-node-type */
	obj_t BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(BgL_nodez00_bglt
		BgL_nodez00_39)
	{
		{	/* Ast/check_type.scm 103 */
			{	/* Ast/check_type.scm 103 */
				obj_t BgL_method1289z00_1765;

				{	/* Ast/check_type.scm 103 */
					obj_t BgL_res2059z00_2415;

					{	/* Ast/check_type.scm 103 */
						long BgL_objzd2classzd2numz00_2380;

						{	/* Ast/check_type.scm 103 */
							long BgL_res2049z00_2383;

							BgL_res2049z00_2383 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_39));
							BgL_objzd2classzd2numz00_2380 = BgL_res2049z00_2383;
						}
						{	/* Ast/check_type.scm 103 */
							obj_t BgL_arg1742z00_2381;

							BgL_arg1742z00_2381 =
								PROCEDURE_REF
								(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
								(int) (((long) 1)));
							{	/* Ast/check_type.scm 103 */
								int BgL_offsetz00_2385;

								BgL_offsetz00_2385 = (int) (BgL_objzd2classzd2numz00_2380);
								{	/* Ast/check_type.scm 103 */
									long BgL_offsetz00_2386;

									BgL_offsetz00_2386 =
										((long) (BgL_offsetz00_2385) - OBJECT_TYPE);
									{	/* Ast/check_type.scm 103 */
										long BgL_modz00_2387;

										BgL_modz00_2387 =
											(BgL_offsetz00_2386 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/check_type.scm 103 */
											long BgL_restz00_2389;

											BgL_restz00_2389 =
												(BgL_offsetz00_2386 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/check_type.scm 103 */

												{	/* Ast/check_type.scm 103 */
													obj_t BgL_bucketz00_2391;

													BgL_bucketz00_2391 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2381), BgL_modz00_2387);
													BgL_res2059z00_2415 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2391), BgL_restz00_2389);
					}}}}}}}}
					BgL_method1289z00_1765 = BgL_res2059z00_2415;
				}
				return
					PROCEDURE_ENTRY(BgL_method1289z00_1765) (BgL_method1289z00_1765,
					((obj_t) BgL_nodez00_39), BEOA);
			}
		}

	}



/* &check-node-type */
	obj_t BGl_z62checkzd2nodezd2typez62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2480, obj_t BgL_nodez00_2481)
	{
		{	/* Ast/check_type.scm 103 */
			return
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				((BgL_nodez00_bglt) BgL_nodez00_2481));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_varz00zzast_nodez00, BGl_proc2081z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_atomz00zzast_nodez00, BGl_proc2083z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_kwotez00zzast_nodez00, BGl_proc2084z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_closurez00zzast_nodez00, BGl_proc2085z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_sequencez00zzast_nodez00, BGl_proc2086z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_syncz00zzast_nodez00, BGl_proc2087z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_setqz00zzast_nodez00, BGl_proc2088z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_conditionalz00zzast_nodez00, BGl_proc2089z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_failz00zzast_nodez00, BGl_proc2090z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_switchz00zzast_nodez00, BGl_proc2091z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2092z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2093z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2094z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc2095z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2096z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2097z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2098z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2099z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_funcallz00zzast_nodez00, BGl_proc2100z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
				BGl_appz00zzast_nodez00, BGl_proc2101z00zzast_checkzd2typezd2,
				BGl_string2082z00zzast_checkzd2typezd2);
		}

	}



/* &check-node-type-app1329 */
	obj_t BGl_z62checkzd2nodezd2typezd2app1329zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2502, obj_t BgL_nodez00_2503)
	{
		{	/* Ast/check_type.scm 310 */
			{	/* Ast/check_type.scm 312 */
				obj_t BgL_g1287z00_2559;

				BgL_g1287z00_2559 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2503)))->BgL_argsz00);
				{
					obj_t BgL_l1285z00_2561;

					BgL_l1285z00_2561 = BgL_g1287z00_2559;
				BgL_zc3z04anonymousza31947ze3z87_2560:
					if (PAIRP(BgL_l1285z00_2561))
						{	/* Ast/check_type.scm 312 */
							{	/* Ast/check_type.scm 312 */
								obj_t BgL_arg1949z00_2562;

								BgL_arg1949z00_2562 = CAR(BgL_l1285z00_2561);
								BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
									((BgL_nodez00_bglt) BgL_arg1949z00_2562));
							}
							{
								obj_t BgL_l1285z00_2993;

								BgL_l1285z00_2993 = CDR(BgL_l1285z00_2561);
								BgL_l1285z00_2561 = BgL_l1285z00_2993;
								goto BgL_zc3z04anonymousza31947ze3z87_2560;
							}
						}
					else
						{	/* Ast/check_type.scm 312 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/check_type.scm 313 */
				bool_t BgL_test2207z00_2995;

				{	/* Ast/check_type.scm 313 */
					BgL_typez00_bglt BgL_arg1960z00_2563;
					BgL_typez00_bglt BgL_arg1961z00_2564;

					BgL_arg1960z00_2563 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_appz00_bglt) BgL_nodez00_2503))))->BgL_typez00);
					BgL_arg1961z00_2564 =
						(((BgL_variablez00_bglt) COBJECT(
								(((BgL_varz00_bglt) COBJECT(
											(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt) BgL_nodez00_2503)))->
												BgL_funz00)))->BgL_variablez00)))->BgL_typez00);
					BgL_test2207z00_2995 =
						BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_arg1960z00_2563,
						BgL_arg1961z00_2564);
				}
				if (BgL_test2207z00_2995)
					{	/* Ast/check_type.scm 313 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 314 */
						BgL_typez00_bglt BgL_arg1956z00_2565;
						BgL_typez00_bglt BgL_arg1957z00_2566;

						BgL_arg1956z00_2565 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_appz00_bglt) BgL_nodez00_2503))))->BgL_typez00);
						BgL_arg1957z00_2566 =
							(((BgL_variablez00_bglt) COBJECT(
									(((BgL_varz00_bglt) COBJECT(
												(((BgL_appz00_bglt) COBJECT(
															((BgL_appz00_bglt) BgL_nodez00_2503)))->
													BgL_funz00)))->BgL_variablez00)))->BgL_typez00);
						return BGl_errz00zzast_checkzd2typezd2(((obj_t) ((BgL_appz00_bglt)
									BgL_nodez00_2503)), BgL_arg1956z00_2565,
							((obj_t) BgL_arg1957z00_2566));
					}
			}
		}

	}



/* &check-node-type-func1327 */
	obj_t BGl_z62checkzd2nodezd2typezd2func1327zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2504, obj_t BgL_nodez00_2505)
	{
		{	/* Ast/check_type.scm 300 */
			{

				if (
					((((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nodez00_2505)))->
							BgL_strengthz00) == CNST_TABLE_REF(((long) 1))))
					{	/* Ast/check_type.scm 302 */
						BFALSE;
					}
				else
					{	/* Ast/check_type.scm 302 */
						BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
							(((BgL_funcallz00_bglt) COBJECT(
										((BgL_funcallz00_bglt) BgL_nodez00_2505)))->BgL_funz00));
					}
				{	/* Ast/check_type.scm 304 */
					obj_t BgL_g1284z00_2570;

					BgL_g1284z00_2570 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2505)))->BgL_argsz00);
					{
						obj_t BgL_l1282z00_2572;

						BgL_l1282z00_2572 = BgL_g1284z00_2570;
					BgL_zc3z04anonymousza31943ze3z87_2571:
						if (PAIRP(BgL_l1282z00_2572))
							{	/* Ast/check_type.scm 304 */
								{	/* Ast/check_type.scm 304 */
									obj_t BgL_arg1945z00_2573;

									BgL_arg1945z00_2573 = CAR(BgL_l1282z00_2572);
									BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
										((BgL_nodez00_bglt) BgL_arg1945z00_2573));
								}
								{
									obj_t BgL_l1282z00_3030;

									BgL_l1282z00_3030 = CDR(BgL_l1282z00_2572);
									BgL_l1282z00_2572 = BgL_l1282z00_3030;
									goto BgL_zc3z04anonymousza31943ze3z87_2571;
								}
							}
						else
							{	/* Ast/check_type.scm 304 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/check_type.scm 300 */
					obj_t BgL_nextzd2method1326zd2_2569;

					BgL_nextzd2method1326zd2_2569 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_funcallz00_bglt) BgL_nodez00_2505)),
						BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
						BGl_funcallz00zzast_nodez00);
					return
						PROCEDURE_ENTRY(BgL_nextzd2method1326zd2_2569)
						(BgL_nextzd2method1326zd2_2569,
						((obj_t) ((BgL_funcallz00_bglt) BgL_nodez00_2505)), BEOA);
				}
			}
		}

	}



/* &check-node-type-app-1325 */
	obj_t BGl_z62checkzd2nodezd2typezd2appzd21325z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2506, obj_t BgL_nodez00_2507)
	{
		{	/* Ast/check_type.scm 291 */
			{

				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2507)))->BgL_funz00));
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2507)))->BgL_argz00));
				{	/* Ast/check_type.scm 291 */
					obj_t BgL_nextzd2method1324zd2_2576;

					BgL_nextzd2method1324zd2_2576 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2507)),
						BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
						BGl_appzd2lyzd2zzast_nodez00);
					return
						PROCEDURE_ENTRY(BgL_nextzd2method1324zd2_2576)
						(BgL_nextzd2method1324zd2_2576,
						((obj_t) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2507)), BEOA);
				}
			}
		}

	}



/* &check-node-type-box-1323 */
	obj_t BGl_z62checkzd2nodezd2typezd2boxzd21323z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2508, obj_t BgL_nodez00_2509)
	{
		{	/* Ast/check_type.scm 281 */
			{	/* Ast/check_type.scm 283 */
				BgL_varz00_bglt BgL_arg1931z00_2578;

				BgL_arg1931z00_2578 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2509)))->BgL_varz00);
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					((BgL_nodez00_bglt) BgL_arg1931z00_2578));
			}
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2509)))->BgL_valuez00));
			{	/* Ast/check_type.scm 285 */
				bool_t BgL_test2210z00_3063;

				{	/* Ast/check_type.scm 285 */
					BgL_typez00_bglt BgL_arg1936z00_2579;

					BgL_arg1936z00_2579 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2509))))->
						BgL_typez00);
					BgL_test2210z00_3063 =
						(((obj_t) BgL_arg1936z00_2579) ==
						BGl_za2unspecza2z00zztype_cachez00);
				}
				if (BgL_test2210z00_3063)
					{	/* Ast/check_type.scm 285 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 286 */
						BgL_typez00_bglt BgL_arg1935z00_2580;

						BgL_arg1935z00_2580 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2509))))->
							BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) (
									(BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2509)),
							BgL_arg1935z00_2580, BGl_za2unspecza2z00zztype_cachez00);
					}
			}
		}

	}



/* &check-node-type-box-1321 */
	obj_t BGl_z62checkzd2nodezd2typezd2boxzd21321z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2510, obj_t BgL_nodez00_2511)
	{
		{	/* Ast/check_type.scm 272 */
			{	/* Ast/check_type.scm 274 */
				BgL_varz00_bglt BgL_arg1921z00_2582;

				BgL_arg1921z00_2582 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_2511)))->BgL_varz00);
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					((BgL_nodez00_bglt) BgL_arg1921z00_2582));
			}
			{	/* Ast/check_type.scm 275 */
				bool_t BgL_test2211z00_3079;

				{	/* Ast/check_type.scm 275 */
					BgL_typez00_bglt BgL_arg1929z00_2583;

					BgL_arg1929z00_2583 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									(((BgL_boxzd2refzd2_bglt) COBJECT(
												((BgL_boxzd2refzd2_bglt) BgL_nodez00_2511)))->
										BgL_varz00))))->BgL_typez00);
					BgL_test2211z00_3079 =
						BGl_eqtypezf3zf3zzast_checkzd2typezd2
						(BGl_za2cellza2z00zztype_cachez00, ((obj_t) BgL_arg1929z00_2583));
				}
				if (BgL_test2211z00_3079)
					{	/* Ast/check_type.scm 275 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 276 */
						BgL_typez00_bglt BgL_arg1925z00_2584;
						BgL_typez00_bglt BgL_arg1926z00_2585;

						BgL_arg1925z00_2584 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_boxzd2refzd2_bglt) BgL_nodez00_2511))))->BgL_typez00);
						BgL_arg1926z00_2585 =
							(((BgL_variablez00_bglt) COBJECT(
									(((BgL_varz00_bglt) COBJECT(
												(((BgL_boxzd2refzd2_bglt) COBJECT(
															((BgL_boxzd2refzd2_bglt) BgL_nodez00_2511)))->
													BgL_varz00)))->BgL_variablez00)))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) ((BgL_boxzd2refzd2_bglt)
									BgL_nodez00_2511)), BgL_arg1925z00_2584,
							((obj_t) BgL_arg1926z00_2585));
					}
			}
		}

	}



/* &check-node-type-make1319 */
	obj_t BGl_z62checkzd2nodezd2typezd2make1319zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2512, obj_t BgL_nodez00_2513)
	{
		{	/* Ast/check_type.scm 263 */
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2513)))->BgL_valuez00));
			{	/* Ast/check_type.scm 266 */
				bool_t BgL_test2212z00_3100;

				{	/* Ast/check_type.scm 266 */
					BgL_typez00_bglt BgL_arg1920z00_2587;

					BgL_arg1920z00_2587 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_2513))))->BgL_typez00);
					BgL_test2212z00_3100 =
						(((obj_t) BgL_arg1920z00_2587) == BGl_za2cellza2z00zztype_cachez00);
				}
				if (BgL_test2212z00_3100)
					{	/* Ast/check_type.scm 266 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 267 */
						BgL_typez00_bglt BgL_arg1919z00_2588;

						BgL_arg1919z00_2588 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_makezd2boxzd2_bglt) BgL_nodez00_2513))))->
							BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) ((BgL_makezd2boxzd2_bglt)
									BgL_nodez00_2513)), BgL_arg1919z00_2588,
							BGl_za2cellza2z00zztype_cachez00);
					}
			}
		}

	}



/* &check-node-type-jump1317 */
	obj_t BGl_z62checkzd2nodezd2typezd2jump1317zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2514, obj_t BgL_nodez00_2515)
	{
		{	/* Ast/check_type.scm 253 */
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2515)))->BgL_exitz00));
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2515)))->BgL_valuez00));
			{	/* Ast/check_type.scm 257 */
				bool_t BgL_test2213z00_3118;

				{	/* Ast/check_type.scm 257 */
					BgL_typez00_bglt BgL_arg1915z00_2590;

					BgL_arg1915z00_2590 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2515))))->
						BgL_typez00);
					BgL_test2213z00_3118 =
						(((obj_t) BgL_arg1915z00_2590) ==
						BGl_za2unspecza2z00zztype_cachez00);
				}
				if (BgL_test2213z00_3118)
					{	/* Ast/check_type.scm 257 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 258 */
						BgL_typez00_bglt BgL_arg1914z00_2591;

						BgL_arg1914z00_2591 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2515))))->
							BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) (
									(BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2515)),
							BgL_arg1914z00_2591, BGl_za2unspecza2z00zztype_cachez00);
					}
			}
		}

	}



/* &check-node-type-set-1315 */
	obj_t BGl_z62checkzd2nodezd2typezd2setzd21315z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2516, obj_t BgL_nodez00_2517)
	{
		{	/* Ast/check_type.scm 243 */
			{	/* Ast/check_type.scm 245 */
				BgL_varz00_bglt BgL_arg1900z00_2593;

				BgL_arg1900z00_2593 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517)))->BgL_varz00);
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					((BgL_nodez00_bglt) BgL_arg1900z00_2593));
			}
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517)))->BgL_bodyz00));
			{	/* Ast/check_type.scm 247 */
				bool_t BgL_test2214z00_3137;

				{	/* Ast/check_type.scm 247 */
					BgL_typez00_bglt BgL_arg1908z00_2594;
					BgL_typez00_bglt BgL_arg1909z00_2595;

					BgL_arg1908z00_2594 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517))))->
						BgL_typez00);
					BgL_arg1909z00_2595 =
						BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt) (
								(BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517)), ((bool_t) 0));
					BgL_test2214z00_3137 =
						BGl_eqtypezf3zf3zzast_checkzd2typezd2(((obj_t) BgL_arg1908z00_2594),
						((obj_t) BgL_arg1909z00_2595));
				}
				if (BgL_test2214z00_3137)
					{	/* Ast/check_type.scm 247 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 248 */
						BgL_typez00_bglt BgL_arg1905z00_2596;
						BgL_typez00_bglt BgL_arg1906z00_2597;

						BgL_arg1905z00_2596 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517))))->
							BgL_typez00);
						BgL_arg1906z00_2597 =
							(((BgL_nodez00_bglt) COBJECT((((BgL_setzd2exzd2itz00_bglt)
											COBJECT(((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517)))->
										BgL_bodyz00)))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) (
									(BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2517)),
							BgL_arg1905z00_2596, ((obj_t) BgL_arg1906z00_2597));
					}
			}
		}

	}



/* &check-node-type-let-1313 */
	obj_t BGl_z62checkzd2nodezd2typezd2letzd21313z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2518, obj_t BgL_nodez00_2519)
	{
		{	/* Ast/check_type.scm 233 */
			{	/* Ast/check_type.scm 235 */
				obj_t BgL_g1281z00_2599;

				BgL_g1281z00_2599 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2519)))->BgL_bindingsz00);
				{
					obj_t BgL_l1279z00_2601;

					BgL_l1279z00_2601 = BgL_g1281z00_2599;
				BgL_zc3z04anonymousza31883ze3z87_2600:
					if (PAIRP(BgL_l1279z00_2601))
						{	/* Ast/check_type.scm 235 */
							{	/* Ast/check_type.scm 235 */
								obj_t BgL_bz00_2602;

								BgL_bz00_2602 = CAR(BgL_l1279z00_2601);
								{	/* Ast/check_type.scm 235 */
									obj_t BgL_arg1885z00_2603;

									BgL_arg1885z00_2603 = CDR(((obj_t) BgL_bz00_2602));
									BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
										((BgL_nodez00_bglt) BgL_arg1885z00_2603));
								}
							}
							{
								obj_t BgL_l1279z00_3166;

								BgL_l1279z00_3166 = CDR(BgL_l1279z00_2601);
								BgL_l1279z00_2601 = BgL_l1279z00_3166;
								goto BgL_zc3z04anonymousza31883ze3z87_2600;
							}
						}
					else
						{	/* Ast/check_type.scm 235 */
							((bool_t) 1);
						}
				}
			}
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2519)))->BgL_bodyz00));
			{	/* Ast/check_type.scm 237 */
				bool_t BgL_test2216z00_3171;

				{	/* Ast/check_type.scm 237 */
					BgL_typez00_bglt BgL_arg1897z00_2604;
					BgL_typez00_bglt BgL_arg1898z00_2605;

					BgL_arg1897z00_2604 =
						(((BgL_nodez00_bglt) COBJECT(
								(((BgL_letzd2varzd2_bglt) COBJECT(
											((BgL_letzd2varzd2_bglt) BgL_nodez00_2519)))->
									BgL_bodyz00)))->BgL_typez00);
					BgL_arg1898z00_2605 =
						(((BgL_nodez00_bglt)
							COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt)
										BgL_nodez00_2519))))->BgL_typez00);
					BgL_test2216z00_3171 =
						BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_arg1897z00_2604,
						BgL_arg1898z00_2605);
				}
				if (BgL_test2216z00_3171)
					{	/* Ast/check_type.scm 237 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 238 */
						BgL_typez00_bglt BgL_arg1894z00_2606;
						BgL_typez00_bglt BgL_arg1895z00_2607;

						BgL_arg1894z00_2606 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_letzd2varzd2_bglt) BgL_nodez00_2519))))->BgL_typez00);
						BgL_arg1895z00_2607 =
							(((BgL_nodez00_bglt) COBJECT(
									(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_nodez00_2519)))->
										BgL_bodyz00)))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) ((BgL_letzd2varzd2_bglt)
									BgL_nodez00_2519)), BgL_arg1894z00_2606,
							((obj_t) BgL_arg1895z00_2607));
					}
			}
		}

	}



/* &check-node-type-let-1311 */
	obj_t BGl_z62checkzd2nodezd2typezd2letzd21311z62zzast_checkzd2typezd2(obj_t
		BgL_envz00_2520, obj_t BgL_nodez00_2521)
	{
		{	/* Ast/check_type.scm 223 */
			{	/* Ast/check_type.scm 225 */
				obj_t BgL_g1278z00_2609;

				BgL_g1278z00_2609 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2521)))->BgL_localsz00);
				{
					obj_t BgL_l1276z00_2611;

					BgL_l1276z00_2611 = BgL_g1278z00_2609;
				BgL_zc3z04anonymousza31867ze3z87_2610:
					if (PAIRP(BgL_l1276z00_2611))
						{	/* Ast/check_type.scm 225 */
							{	/* Ast/check_type.scm 225 */
								obj_t BgL_arg1870z00_2612;

								BgL_arg1870z00_2612 = CAR(BgL_l1276z00_2611);
								{	/* Ast/check_type.scm 69 */
									BgL_valuez00_bglt BgL_funz00_2613;

									BgL_funz00_2613 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt) BgL_arg1870z00_2612)))->
										BgL_valuez00);
									{	/* Ast/check_type.scm 69 */
										obj_t BgL_bodyz00_2614;

										BgL_bodyz00_2614 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_funz00_2613)))->BgL_bodyz00);
										{	/* Ast/check_type.scm 70 */

											BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
												((BgL_nodez00_bglt) BgL_bodyz00_2614));
										}
									}
								}
							}
							{
								obj_t BgL_l1276z00_3200;

								BgL_l1276z00_3200 = CDR(BgL_l1276z00_2611);
								BgL_l1276z00_2611 = BgL_l1276z00_3200;
								goto BgL_zc3z04anonymousza31867ze3z87_2610;
							}
						}
					else
						{	/* Ast/check_type.scm 225 */
							((bool_t) 1);
						}
				}
			}
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2521)))->BgL_bodyz00));
			{	/* Ast/check_type.scm 227 */
				bool_t BgL_test2218z00_3205;

				{	/* Ast/check_type.scm 227 */
					BgL_typez00_bglt BgL_arg1880z00_2615;
					BgL_typez00_bglt BgL_arg1881z00_2616;

					BgL_arg1880z00_2615 =
						(((BgL_nodez00_bglt) COBJECT(
								(((BgL_letzd2funzd2_bglt) COBJECT(
											((BgL_letzd2funzd2_bglt) BgL_nodez00_2521)))->
									BgL_bodyz00)))->BgL_typez00);
					BgL_arg1881z00_2616 =
						(((BgL_nodez00_bglt)
							COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt)
										BgL_nodez00_2521))))->BgL_typez00);
					BgL_test2218z00_3205 =
						BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_arg1880z00_2615,
						BgL_arg1881z00_2616);
				}
				if (BgL_test2218z00_3205)
					{	/* Ast/check_type.scm 227 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 228 */
						BgL_typez00_bglt BgL_arg1877z00_2617;
						BgL_typez00_bglt BgL_arg1878z00_2618;

						BgL_arg1877z00_2617 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2521))))->BgL_typez00);
						BgL_arg1878z00_2618 =
							(((BgL_nodez00_bglt) COBJECT(
									(((BgL_letzd2funzd2_bglt) COBJECT(
												((BgL_letzd2funzd2_bglt) BgL_nodez00_2521)))->
										BgL_bodyz00)))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(((obj_t) ((BgL_letzd2funzd2_bglt)
									BgL_nodez00_2521)), BgL_arg1877z00_2617,
							((obj_t) BgL_arg1878z00_2618));
					}
			}
		}

	}



/* &check-node-type-swit1309 */
	obj_t BGl_z62checkzd2nodezd2typezd2swit1309zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2522, obj_t BgL_nodez00_2523)
	{
		{	/* Ast/check_type.scm 207 */
			{

				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2523)))->BgL_testz00));
				{
					obj_t BgL_clausesz00_2623;

					BgL_clausesz00_2623 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2523)))->BgL_clausesz00);
				BgL_loopz00_2622:
					if (NULLP(BgL_clausesz00_2623))
						{	/* Ast/check_type.scm 211 */
							{	/* Ast/check_type.scm 207 */
								obj_t BgL_nextzd2method1308zd2_2621;

								BgL_nextzd2method1308zd2_2621 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									((BgL_objectz00_bglt)
										((BgL_switchz00_bglt) BgL_nodez00_2523)),
									BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
									BGl_switchz00zzast_nodez00);
								return
									PROCEDURE_ENTRY(BgL_nextzd2method1308zd2_2621)
									(BgL_nextzd2method1308zd2_2621,
									((obj_t) ((BgL_switchz00_bglt) BgL_nodez00_2523)), BEOA);
							}
						}
					else
						{	/* Ast/check_type.scm 213 */
							obj_t BgL_clausez00_2624;

							BgL_clausez00_2624 = CAR(((obj_t) BgL_clausesz00_2623));
							{	/* Ast/check_type.scm 214 */
								obj_t BgL_arg1858z00_2625;

								BgL_arg1858z00_2625 = CDR(((obj_t) BgL_clausez00_2624));
								BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
									((BgL_nodez00_bglt) BgL_arg1858z00_2625));
							}
							{	/* Ast/check_type.scm 215 */
								BgL_typez00_bglt BgL_ntypez00_2626;

								BgL_ntypez00_2626 =
									(((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												CDR(((obj_t) BgL_clausez00_2624)))))->BgL_typez00);
								{	/* Ast/check_type.scm 216 */
									bool_t BgL_test2220z00_3247;

									{	/* Ast/check_type.scm 216 */
										BgL_typez00_bglt BgL_arg1865z00_2627;

										BgL_arg1865z00_2627 =
											(((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_switchz00_bglt) BgL_nodez00_2523))))->
											BgL_typez00);
										BgL_test2220z00_3247 =
											BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_ntypez00_2626,
											BgL_arg1865z00_2627);
									}
									if (BgL_test2220z00_3247)
										{	/* Ast/check_type.scm 217 */
											obj_t BgL_arg1861z00_2628;

											BgL_arg1861z00_2628 = CDR(((obj_t) BgL_clausesz00_2623));
											{
												obj_t BgL_clausesz00_3254;

												BgL_clausesz00_3254 = BgL_arg1861z00_2628;
												BgL_clausesz00_2623 = BgL_clausesz00_3254;
												goto BgL_loopz00_2622;
											}
										}
									else
										{	/* Ast/check_type.scm 218 */
											obj_t BgL_arg1862z00_2629;
											BgL_typez00_bglt BgL_arg1863z00_2630;

											BgL_arg1862z00_2629 = CDR(((obj_t) BgL_clausez00_2624));
											BgL_arg1863z00_2630 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt)
															((BgL_switchz00_bglt) BgL_nodez00_2523))))->
												BgL_typez00);
											return
												BGl_errz00zzast_checkzd2typezd2(BgL_arg1862z00_2629,
												BgL_ntypez00_2626, ((obj_t) BgL_arg1863z00_2630));
										}
								}
							}
						}
				}
			}
		}

	}



/* &check-node-type-fail1307 */
	obj_t BGl_z62checkzd2nodezd2typezd2fail1307zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2524, obj_t BgL_nodez00_2525)
	{
		{	/* Ast/check_type.scm 196 */
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2525)))->BgL_procz00));
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2525)))->BgL_msgz00));
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2525)))->BgL_objz00));
			{	/* Ast/check_type.scm 201 */
				bool_t BgL_test2221z00_3273;

				{	/* Ast/check_type.scm 201 */
					BgL_typez00_bglt BgL_arg1852z00_2632;

					BgL_arg1852z00_2632 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_failz00_bglt) BgL_nodez00_2525))))->BgL_typez00);
					BgL_test2221z00_3273 =
						(
						((obj_t) BgL_arg1852z00_2632) == BGl_za2magicza2z00zztype_cachez00);
				}
				if (BgL_test2221z00_3273)
					{	/* Ast/check_type.scm 201 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 202 */
						BgL_typez00_bglt BgL_arg1850z00_2633;

						BgL_arg1850z00_2633 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_failz00_bglt) BgL_nodez00_2525))))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(
							((obj_t)
								((BgL_failz00_bglt) BgL_nodez00_2525)), BgL_arg1850z00_2633,
							BGl_za2magicza2z00zztype_cachez00);
					}
			}
		}

	}



/* &check-node-type-cond1305 */
	obj_t BGl_z62checkzd2nodezd2typezd2cond1305zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2526, obj_t BgL_nodez00_2527)
	{
		{	/* Ast/check_type.scm 186 */
			{

				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2527)))->BgL_testz00));
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2527)))->BgL_truez00));
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2527)))->BgL_falsez00));
				{	/* Ast/check_type.scm 186 */
					obj_t BgL_nextzd2method1304zd2_2636;

					BgL_nextzd2method1304zd2_2636 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_conditionalz00_bglt) BgL_nodez00_2527)),
						BGl_checkzd2nodezd2typezd2envzd2zzast_checkzd2typezd2,
						BGl_conditionalz00zzast_nodez00);
					return
						PROCEDURE_ENTRY(BgL_nextzd2method1304zd2_2636)
						(BgL_nextzd2method1304zd2_2636,
						((obj_t) ((BgL_conditionalz00_bglt) BgL_nodez00_2527)), BEOA);
				}
			}
		}

	}



/* &check-node-type-setq1303 */
	obj_t BGl_z62checkzd2nodezd2typezd2setq1303zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2528, obj_t BgL_nodez00_2529)
	{
		{	/* Ast/check_type.scm 176 */
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2529)))->BgL_valuez00));
			{	/* Ast/check_type.scm 179 */
				BgL_varz00_bglt BgL_arg1834z00_2638;

				BgL_arg1834z00_2638 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2529)))->BgL_varz00);
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
					((BgL_nodez00_bglt) BgL_arg1834z00_2638));
			}
			{	/* Ast/check_type.scm 180 */
				bool_t BgL_test2222z00_3310;

				{	/* Ast/check_type.scm 180 */
					BgL_typez00_bglt BgL_arg1838z00_2639;

					BgL_arg1838z00_2639 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_setqz00_bglt) BgL_nodez00_2529))))->BgL_typez00);
					BgL_test2222z00_3310 =
						(
						((obj_t) BgL_arg1838z00_2639) ==
						BGl_za2unspecza2z00zztype_cachez00);
				}
				if (BgL_test2222z00_3310)
					{	/* Ast/check_type.scm 180 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 181 */
						BgL_typez00_bglt BgL_arg1837z00_2640;

						BgL_arg1837z00_2640 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_setqz00_bglt) BgL_nodez00_2529))))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(
							((obj_t)
								((BgL_setqz00_bglt) BgL_nodez00_2529)), BgL_arg1837z00_2640,
							BGl_za2unspecza2z00zztype_cachez00);
					}
			}
		}

	}



/* &check-node-type-sync1301 */
	obj_t BGl_z62checkzd2nodezd2typezd2sync1301zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2530, obj_t BgL_nodez00_2531)
	{
		{	/* Ast/check_type.scm 167 */
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2531)))->BgL_mutexz00));
			BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2531)))->BgL_prelockz00));
			return
				BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2531)))->BgL_bodyz00));
		}

	}



/* &check-node-type-sequ1299 */
	obj_t BGl_z62checkzd2nodezd2typezd2sequ1299zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2532, obj_t BgL_nodez00_2533)
	{
		{	/* Ast/check_type.scm 154 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2533)))->BgL_nodesz00)))
				{	/* Ast/check_type.scm 161 */
					bool_t BgL_test2224z00_3335;

					{	/* Ast/check_type.scm 161 */
						BgL_typez00_bglt BgL_arg1826z00_2643;

						BgL_arg1826z00_2643 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_sequencez00_bglt) BgL_nodez00_2533))))->BgL_typez00);
						BgL_test2224z00_3335 =
							BGl_eqtypezf3zf3zzast_checkzd2typezd2(
							((obj_t) BgL_arg1826z00_2643),
							BGl_za2unspecza2z00zztype_cachez00);
					}
					if (BgL_test2224z00_3335)
						{	/* Ast/check_type.scm 161 */
							return BFALSE;
						}
					else
						{	/* Ast/check_type.scm 162 */
							BgL_typez00_bglt BgL_arg1825z00_2644;

							BgL_arg1825z00_2644 =
								(((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_sequencez00_bglt) BgL_nodez00_2533))))->
								BgL_typez00);
							return
								BGl_errz00zzast_checkzd2typezd2(((obj_t) ((BgL_sequencez00_bglt)
										BgL_nodez00_2533)), BgL_arg1825z00_2644,
								BGl_za2unspecza2z00zztype_cachez00);
						}
				}
			else
				{	/* Ast/check_type.scm 156 */
					{	/* Ast/check_type.scm 158 */
						obj_t BgL_g1275z00_2645;

						BgL_g1275z00_2645 =
							(((BgL_sequencez00_bglt) COBJECT(
									((BgL_sequencez00_bglt) BgL_nodez00_2533)))->BgL_nodesz00);
						{
							obj_t BgL_l1273z00_2647;

							BgL_l1273z00_2647 = BgL_g1275z00_2645;
						BgL_zc3z04anonymousza31797ze3z87_2646:
							if (PAIRP(BgL_l1273z00_2647))
								{	/* Ast/check_type.scm 158 */
									{	/* Ast/check_type.scm 158 */
										obj_t BgL_arg1799z00_2648;

										BgL_arg1799z00_2648 = CAR(BgL_l1273z00_2647);
										BGl_checkzd2nodezd2typez00zzast_checkzd2typezd2(
											((BgL_nodez00_bglt) BgL_arg1799z00_2648));
									}
									{
										obj_t BgL_l1273z00_3354;

										BgL_l1273z00_3354 = CDR(BgL_l1273z00_2647);
										BgL_l1273z00_2647 = BgL_l1273z00_3354;
										goto BgL_zc3z04anonymousza31797ze3z87_2646;
									}
								}
							else
								{	/* Ast/check_type.scm 158 */
									((bool_t) 1);
								}
						}
					}
					{	/* Ast/check_type.scm 159 */
						bool_t BgL_test2226z00_3356;

						{	/* Ast/check_type.scm 159 */
							BgL_typez00_bglt BgL_arg1817z00_2649;
							BgL_typez00_bglt BgL_arg1819z00_2650;

							BgL_arg1817z00_2649 =
								(((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
													(((BgL_sequencez00_bglt) COBJECT(
																((BgL_sequencez00_bglt) BgL_nodez00_2533)))->
														BgL_nodesz00))))))->BgL_typez00);
							BgL_arg1819z00_2650 =
								(((BgL_nodez00_bglt)
									COBJECT(((BgL_nodez00_bglt) ((BgL_sequencez00_bglt)
												BgL_nodez00_2533))))->BgL_typez00);
							BgL_test2226z00_3356 =
								BGl_subtypezf3zf3zzast_checkzd2typezd2(BgL_arg1817z00_2649,
								BgL_arg1819z00_2650);
						}
						if (BgL_test2226z00_3356)
							{	/* Ast/check_type.scm 159 */
								return BFALSE;
							}
						else
							{	/* Ast/check_type.scm 160 */
								BgL_typez00_bglt BgL_arg1812z00_2651;
								BgL_typez00_bglt BgL_arg1813z00_2652;

								BgL_arg1812z00_2651 =
									(((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
														(((BgL_sequencez00_bglt) COBJECT(
																	((BgL_sequencez00_bglt) BgL_nodez00_2533)))->
															BgL_nodesz00))))))->BgL_typez00);
								BgL_arg1813z00_2652 =
									(((BgL_nodez00_bglt)
										COBJECT(((BgL_nodez00_bglt) ((BgL_sequencez00_bglt)
													BgL_nodez00_2533))))->BgL_typez00);
								return
									BGl_errz00zzast_checkzd2typezd2(((obj_t) (
											(BgL_sequencez00_bglt) BgL_nodez00_2533)),
									BgL_arg1812z00_2651, ((obj_t) BgL_arg1813z00_2652));
							}
					}
				}
		}

	}



/* &check-node-type-clos1297 */
	obj_t BGl_z62checkzd2nodezd2typezd2clos1297zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2534, obj_t BgL_nodez00_2535)
	{
		{	/* Ast/check_type.scm 146 */
			{	/* Ast/check_type.scm 148 */
				bool_t BgL_test2227z00_3380;

				{	/* Ast/check_type.scm 148 */
					BgL_typez00_bglt BgL_arg1794z00_2654;

					BgL_arg1794z00_2654 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_closurez00_bglt) BgL_nodez00_2535))))->BgL_typez00);
					BgL_test2227z00_3380 =
						(
						((obj_t) BgL_arg1794z00_2654) ==
						BGl_za2procedureza2z00zztype_cachez00);
				}
				if (BgL_test2227z00_3380)
					{	/* Ast/check_type.scm 148 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 149 */
						BgL_typez00_bglt BgL_arg1793z00_2655;

						BgL_arg1793z00_2655 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_closurez00_bglt) BgL_nodez00_2535))))->BgL_typez00);
						return
							BGl_errz00zzast_checkzd2typezd2(
							((obj_t)
								((BgL_closurez00_bglt) BgL_nodez00_2535)), BgL_arg1793z00_2655,
							BGl_za2procedureza2z00zztype_cachez00);
					}
			}
		}

	}



/* &check-node-type-kwot1295 */
	obj_t BGl_z62checkzd2nodezd2typezd2kwot1295zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2536, obj_t BgL_nodez00_2537)
	{
		{	/* Ast/check_type.scm 138 */
			{	/* Ast/check_type.scm 140 */
				bool_t BgL_test2228z00_3392;

				{	/* Ast/check_type.scm 140 */
					BgL_typez00_bglt BgL_arg1788z00_2657;
					BgL_typez00_bglt BgL_arg1789z00_2658;

					BgL_arg1788z00_2657 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_kwotez00_bglt) BgL_nodez00_2537))))->BgL_typez00);
					BgL_arg1789z00_2658 =
						BGl_getzd2typezd2kwotez00zztype_typeofz00(
						(((BgL_kwotez00_bglt) COBJECT(
									((BgL_kwotez00_bglt) BgL_nodez00_2537)))->BgL_valuez00));
					BgL_test2228z00_3392 =
						BGl_eqtypezf3zf3zzast_checkzd2typezd2(
						((obj_t) BgL_arg1788z00_2657), ((obj_t) BgL_arg1789z00_2658));
				}
				if (BgL_test2228z00_3392)
					{	/* Ast/check_type.scm 140 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 141 */
						BgL_typez00_bglt BgL_arg1784z00_2659;
						BgL_typez00_bglt BgL_arg1786z00_2660;

						BgL_arg1784z00_2659 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_kwotez00_bglt) BgL_nodez00_2537))))->BgL_typez00);
						BgL_arg1786z00_2660 =
							BGl_getzd2typezd2kwotez00zztype_typeofz00(
							(((BgL_kwotez00_bglt) COBJECT(
										((BgL_kwotez00_bglt) BgL_nodez00_2537)))->BgL_valuez00));
						return
							BGl_errz00zzast_checkzd2typezd2(
							((obj_t)
								((BgL_kwotez00_bglt) BgL_nodez00_2537)), BgL_arg1784z00_2659,
							((obj_t) BgL_arg1786z00_2660));
					}
			}
		}

	}



/* &check-node-type-atom1293 */
	obj_t BGl_z62checkzd2nodezd2typezd2atom1293zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2538, obj_t BgL_nodez00_2539)
	{
		{	/* Ast/check_type.scm 130 */
			{	/* Ast/check_type.scm 132 */
				bool_t BgL_test2229z00_3412;

				{	/* Ast/check_type.scm 132 */
					BgL_typez00_bglt BgL_arg1775z00_2662;
					BgL_typez00_bglt BgL_arg1776z00_2663;

					BgL_arg1775z00_2662 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_atomz00_bglt) BgL_nodez00_2539))))->BgL_typez00);
					BgL_arg1776z00_2663 =
						BGl_getzd2typezd2atomz00zztype_typeofz00(
						(((BgL_atomz00_bglt) COBJECT(
									((BgL_atomz00_bglt) BgL_nodez00_2539)))->BgL_valuez00));
					BgL_test2229z00_3412 =
						BGl_atomzd2subtypezf3z21zzast_checkzd2typezd2(BgL_arg1775z00_2662,
						BgL_arg1776z00_2663);
				}
				if (BgL_test2229z00_3412)
					{	/* Ast/check_type.scm 132 */
						return BFALSE;
					}
				else
					{	/* Ast/check_type.scm 133 */
						BgL_typez00_bglt BgL_arg1770z00_2664;
						BgL_typez00_bglt BgL_arg1771z00_2665;

						BgL_arg1770z00_2664 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_atomz00_bglt) BgL_nodez00_2539))))->BgL_typez00);
						BgL_arg1771z00_2665 =
							BGl_getzd2typezd2atomz00zztype_typeofz00(
							(((BgL_atomz00_bglt) COBJECT(
										((BgL_atomz00_bglt) BgL_nodez00_2539)))->BgL_valuez00));
						return
							BGl_errz00zzast_checkzd2typezd2(
							((obj_t)
								((BgL_atomz00_bglt) BgL_nodez00_2539)), BgL_arg1770z00_2664,
							((obj_t) BgL_arg1771z00_2665));
					}
			}
		}

	}



/* &check-node-type-var1291 */
	obj_t BGl_z62checkzd2nodezd2typezd2var1291zb0zzast_checkzd2typezd2(obj_t
		BgL_envz00_2540, obj_t BgL_nodez00_2541)
	{
		{	/* Ast/check_type.scm 110 */
			{	/* Ast/check_type.scm 112 */
				BgL_variablez00_bglt BgL_i1115z00_2667;

				BgL_i1115z00_2667 =
					(((BgL_varz00_bglt) COBJECT(
							((BgL_varz00_bglt) BgL_nodez00_2541)))->BgL_variablez00);
				{	/* Ast/check_type.scm 113 */
					bool_t BgL_test2230z00_3432;

					{	/* Ast/check_type.scm 113 */
						BgL_valuez00_bglt BgL_arg1763z00_2668;

						BgL_arg1763z00_2668 =
							(((BgL_variablez00_bglt) COBJECT(
									(((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_nodez00_2541)))->
										BgL_variablez00)))->BgL_valuez00);
						{	/* Ast/check_type.scm 113 */
							bool_t BgL_res2060z00_2669;

							BgL_res2060z00_2669 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg1763z00_2668), BGl_sfunz00zzast_varz00);
							BgL_test2230z00_3432 = BgL_res2060z00_2669;
						}
					}
					if (BgL_test2230z00_3432)
						{	/* Ast/check_type.scm 113 */
							return BFALSE;
						}
					else
						{	/* Ast/check_type.scm 113 */
							{	/* Ast/check_type.scm 114 */
								bool_t BgL_test2231z00_3438;

								{	/* Ast/check_type.scm 114 */
									bool_t BgL_test2232z00_3439;

									{	/* Ast/check_type.scm 114 */
										BgL_typez00_bglt BgL_arg1716z00_2670;
										BgL_typez00_bglt BgL_arg1719z00_2671;

										BgL_arg1716z00_2670 =
											(((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt)
														((BgL_varz00_bglt) BgL_nodez00_2541))))->
											BgL_typez00);
										BgL_arg1719z00_2671 =
											(((BgL_variablez00_bglt) COBJECT(BgL_i1115z00_2667))->
											BgL_typez00);
										BgL_test2232z00_3439 =
											BGl_subtypezf3zf3zzast_checkzd2typezd2
											(BgL_arg1716z00_2670, BgL_arg1719z00_2671);
									}
									if (BgL_test2232z00_3439)
										{	/* Ast/check_type.scm 114 */
											BgL_test2231z00_3438 = ((bool_t) 1);
										}
									else
										{	/* Ast/check_type.scm 115 */
											bool_t BgL_test2233z00_3445;

											{	/* Ast/check_type.scm 115 */
												bool_t BgL_test2234z00_3446;

												{	/* Ast/check_type.scm 115 */
													BgL_typez00_bglt BgL_arg1715z00_2672;

													BgL_arg1715z00_2672 =
														(((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt)
																	((BgL_varz00_bglt) BgL_nodez00_2541))))->
														BgL_typez00);
													BgL_test2234z00_3446 =
														(((obj_t) BgL_arg1715z00_2672) ==
														BGl_za2objza2z00zztype_cachez00);
												}
												if (BgL_test2234z00_3446)
													{	/* Ast/check_type.scm 115 */
														BgL_test2233z00_3445 =
															BGl_bigloozd2typezf3z21zztype_typez00(
															(((BgL_variablez00_bglt)
																	COBJECT(BgL_i1115z00_2667))->BgL_typez00));
													}
												else
													{	/* Ast/check_type.scm 115 */
														BgL_test2233z00_3445 = ((bool_t) 0);
													}
											}
											if (BgL_test2233z00_3445)
												{	/* Ast/check_type.scm 115 */
													BgL_test2231z00_3438 = ((bool_t) 1);
												}
											else
												{	/* Ast/check_type.scm 116 */
													bool_t BgL_test2235z00_3454;

													{	/* Ast/check_type.scm 116 */
														BgL_typez00_bglt BgL_arg1708z00_2673;

														BgL_arg1708z00_2673 =
															(((BgL_variablez00_bglt)
																COBJECT(BgL_i1115z00_2667))->BgL_typez00);
														{	/* Ast/check_type.scm 116 */
															bool_t BgL_res2061z00_2674;

															BgL_res2061z00_2674 =
																BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_arg1708z00_2673),
																BGl_tclassz00zzobject_classz00);
															BgL_test2235z00_3454 = BgL_res2061z00_2674;
														}
													}
													if (BgL_test2235z00_3454)
														{	/* Ast/check_type.scm 116 */
															BgL_typez00_bglt BgL_arg1705z00_2675;
															BgL_typez00_bglt BgL_arg1706z00_2676;

															BgL_arg1705z00_2675 =
																(((BgL_variablez00_bglt)
																	COBJECT(BgL_i1115z00_2667))->BgL_typez00);
															BgL_arg1706z00_2676 =
																(((BgL_nodez00_bglt)
																	COBJECT(((BgL_nodez00_bglt) ((BgL_varz00_bglt)
																				BgL_nodez00_2541))))->BgL_typez00);
															BgL_test2231z00_3438 =
																BGl_subtypezf3zf3zzast_checkzd2typezd2
																(BgL_arg1705z00_2675, BgL_arg1706z00_2676);
														}
													else
														{	/* Ast/check_type.scm 116 */
															BgL_test2231z00_3438 = ((bool_t) 0);
														}
												}
										}
								}
								if (BgL_test2231z00_3438)
									{	/* Ast/check_type.scm 114 */
										BFALSE;
									}
								else
									{	/* Ast/check_type.scm 114 */
										{	/* Ast/check_type.scm 117 */
											obj_t BgL_arg1641z00_2677;
											obj_t BgL_arg1642z00_2678;
											obj_t BgL_arg1645z00_2679;
											obj_t BgL_arg1648z00_2680;
											obj_t BgL_arg1649z00_2681;
											bool_t BgL_arg1651z00_2682;
											bool_t BgL_arg1654z00_2683;

											{	/* Ast/check_type.scm 117 */
												obj_t BgL_res2062z00_2684;

												{	/* Ast/check_type.scm 117 */
													obj_t BgL_tmpz00_3463;

													BgL_tmpz00_3463 = BGL_CURRENT_DYNAMIC_ENV();
													BgL_res2062z00_2684 =
														BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3463);
												}
												BgL_arg1641z00_2677 = BgL_res2062z00_2684;
											}
											BgL_arg1642z00_2678 =
												BGl_shapez00zztools_shapez00(
												((obj_t) ((BgL_varz00_bglt) BgL_nodez00_2541)));
											BgL_arg1645z00_2679 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt)
															((BgL_varz00_bglt) BgL_nodez00_2541))))->
												BgL_locz00);
											{	/* Ast/check_type.scm 118 */
												BgL_typez00_bglt BgL_arg1689z00_2685;

												BgL_arg1689z00_2685 =
													(((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt)
																((BgL_varz00_bglt) BgL_nodez00_2541))))->
													BgL_typez00);
												BgL_arg1648z00_2680 =
													BGl_shapez00zztools_shapez00(((obj_t)
														BgL_arg1689z00_2685));
											}
											{	/* Ast/check_type.scm 118 */
												BgL_typez00_bglt BgL_arg1692z00_2686;

												BgL_arg1692z00_2686 =
													(((BgL_variablez00_bglt) COBJECT(BgL_i1115z00_2667))->
													BgL_typez00);
												BgL_arg1649z00_2681 =
													BGl_shapez00zztools_shapez00(((obj_t)
														BgL_arg1692z00_2686));
											}
											BgL_arg1651z00_2682 =
												(
												((obj_t)
													(((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt)
																	((BgL_varz00_bglt) BgL_nodez00_2541))))->
														BgL_typez00)) ==
												((obj_t) (((BgL_variablez00_bglt)
															COBJECT(BgL_i1115z00_2667))->BgL_typez00)));
											{	/* Ast/check_type.scm 119 */
												BgL_typez00_bglt BgL_arg1695z00_2687;
												BgL_typez00_bglt BgL_arg1696z00_2688;

												BgL_arg1695z00_2687 =
													(((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt)
																((BgL_varz00_bglt) BgL_nodez00_2541))))->
													BgL_typez00);
												BgL_arg1696z00_2688 =
													(((BgL_variablez00_bglt) COBJECT(BgL_i1115z00_2667))->
													BgL_typez00);
												BgL_arg1654z00_2683 =
													BGl_subtypezf3zf3zzast_checkzd2typezd2
													(BgL_arg1695z00_2687, BgL_arg1696z00_2688);
											}
											{	/* Ast/check_type.scm 117 */
												obj_t BgL_list1655z00_2689;

												{	/* Ast/check_type.scm 117 */
													obj_t BgL_arg1658z00_2690;

													{	/* Ast/check_type.scm 117 */
														obj_t BgL_arg1659z00_2691;

														{	/* Ast/check_type.scm 117 */
															obj_t BgL_arg1660z00_2692;

															{	/* Ast/check_type.scm 117 */
																obj_t BgL_arg1661z00_2693;

																{	/* Ast/check_type.scm 117 */
																	obj_t BgL_arg1664z00_2694;

																	{	/* Ast/check_type.scm 117 */
																		obj_t BgL_arg1665z00_2695;

																		{	/* Ast/check_type.scm 117 */
																			obj_t BgL_arg1666z00_2696;

																			{	/* Ast/check_type.scm 117 */
																				obj_t BgL_arg1668z00_2697;

																				{	/* Ast/check_type.scm 117 */
																					obj_t BgL_arg1669z00_2698;

																					{	/* Ast/check_type.scm 117 */
																						obj_t BgL_arg1671z00_2699;

																						{	/* Ast/check_type.scm 117 */
																							obj_t BgL_arg1674z00_2700;

																							{	/* Ast/check_type.scm 117 */
																								obj_t BgL_arg1675z00_2701;

																								{	/* Ast/check_type.scm 117 */
																									obj_t BgL_arg1677z00_2702;

																									{	/* Ast/check_type.scm 117 */
																										obj_t BgL_arg1679z00_2703;

																										{	/* Ast/check_type.scm 117 */
																											obj_t BgL_arg1680z00_2704;

																											{	/* Ast/check_type.scm 117 */
																												obj_t
																													BgL_arg1681z00_2705;
																												{	/* Ast/check_type.scm 117 */
																													obj_t
																														BgL_arg1682z00_2706;
																													BgL_arg1682z00_2706 =
																														MAKE_YOUNG_PAIR
																														(BBOOL
																														(BGl_za2checkzd2fullza2zd2zzast_checkzd2typezd2),
																														BNIL);
																													BgL_arg1681z00_2705 =
																														MAKE_YOUNG_PAIR
																														(BGl_string2102z00zzast_checkzd2typezd2,
																														BgL_arg1682z00_2706);
																												}
																												BgL_arg1680z00_2704 =
																													MAKE_YOUNG_PAIR(BBOOL
																													(BgL_arg1654z00_2683),
																													BgL_arg1681z00_2705);
																											}
																											BgL_arg1679z00_2703 =
																												MAKE_YOUNG_PAIR
																												(BGl_string2103z00zzast_checkzd2typezd2,
																												BgL_arg1680z00_2704);
																										}
																										BgL_arg1677z00_2702 =
																											MAKE_YOUNG_PAIR(BBOOL
																											(BgL_arg1651z00_2682),
																											BgL_arg1679z00_2703);
																									}
																									BgL_arg1675z00_2701 =
																										MAKE_YOUNG_PAIR
																										(BGl_string2104z00zzast_checkzd2typezd2,
																										BgL_arg1677z00_2702);
																								}
																								BgL_arg1674z00_2700 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1649z00_2681,
																									BgL_arg1675z00_2701);
																							}
																							BgL_arg1671z00_2699 =
																								MAKE_YOUNG_PAIR
																								(BGl_string2105z00zzast_checkzd2typezd2,
																								BgL_arg1674z00_2700);
																						}
																						BgL_arg1669z00_2698 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1648z00_2680,
																							BgL_arg1671z00_2699);
																					}
																					BgL_arg1668z00_2697 =
																						MAKE_YOUNG_PAIR
																						(BGl_string2106z00zzast_checkzd2typezd2,
																						BgL_arg1669z00_2698);
																				}
																				BgL_arg1666z00_2696 =
																					MAKE_YOUNG_PAIR(BgL_arg1645z00_2679,
																					BgL_arg1668z00_2697);
																			}
																			BgL_arg1665z00_2695 =
																				MAKE_YOUNG_PAIR
																				(BGl_string2107z00zzast_checkzd2typezd2,
																				BgL_arg1666z00_2696);
																		}
																		BgL_arg1664z00_2694 =
																			MAKE_YOUNG_PAIR(BgL_arg1642z00_2678,
																			BgL_arg1665z00_2695);
																	}
																	BgL_arg1661z00_2693 =
																		MAKE_YOUNG_PAIR
																		(BGl_string2108z00zzast_checkzd2typezd2,
																		BgL_arg1664z00_2694);
																}
																BgL_arg1660z00_2692 =
																	MAKE_YOUNG_PAIR
																	(BGl_string2109z00zzast_checkzd2typezd2,
																	BgL_arg1661z00_2693);
															}
															BgL_arg1659z00_2691 =
																MAKE_YOUNG_PAIR(BINT(((long) 117)),
																BgL_arg1660z00_2692);
														}
														BgL_arg1658z00_2690 =
															MAKE_YOUNG_PAIR
															(BGl_string2110z00zzast_checkzd2typezd2,
															BgL_arg1659z00_2691);
													}
													BgL_list1655z00_2689 =
														MAKE_YOUNG_PAIR
														(BGl_string2111z00zzast_checkzd2typezd2,
														BgL_arg1658z00_2690);
												}
												BGl_tprintz00zz__r4_output_6_10_3z00
													(BgL_arg1641z00_2677, BgL_list1655z00_2689);
										}}
										{	/* Ast/check_type.scm 121 */
											BgL_typez00_bglt BgL_arg1702z00_2707;
											BgL_typez00_bglt BgL_arg1703z00_2708;

											BgL_arg1702z00_2707 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt)
															((BgL_varz00_bglt) BgL_nodez00_2541))))->
												BgL_typez00);
											BgL_arg1703z00_2708 =
												(((BgL_variablez00_bglt) COBJECT(BgL_i1115z00_2667))->
												BgL_typez00);
											BGl_errz00zzast_checkzd2typezd2(((obj_t) (
														(BgL_varz00_bglt) BgL_nodez00_2541)),
												BgL_arg1702z00_2707, ((obj_t) BgL_arg1703z00_2708));
							}}}
							{	/* Ast/check_type.scm 122 */
								bool_t BgL_test2236z00_3523;

								{	/* Ast/check_type.scm 122 */
									bool_t BgL_test2237z00_3524;

									{	/* Ast/check_type.scm 122 */
										BgL_typez00_bglt BgL_arg1762z00_2709;

										BgL_arg1762z00_2709 =
											(((BgL_variablez00_bglt) COBJECT(BgL_i1115z00_2667))->
											BgL_typez00);
										BgL_test2237z00_3524 =
											(((obj_t) BgL_arg1762z00_2709) ==
											BGl_za2_za2z00zztype_cachez00);
									}
									if (BgL_test2237z00_3524)
										{	/* Ast/check_type.scm 123 */
											bool_t BgL_test2238z00_3528;

											{	/* Ast/check_type.scm 123 */
												BgL_variablez00_bglt BgL_arg1761z00_2710;

												BgL_arg1761z00_2710 =
													(((BgL_varz00_bglt) COBJECT(
															((BgL_varz00_bglt) BgL_nodez00_2541)))->
													BgL_variablez00);
												{	/* Ast/check_type.scm 123 */
													bool_t BgL_res2063z00_2711;

													BgL_res2063z00_2711 =
														BGl_isazf3zf3zz__objectz00(
														((obj_t) BgL_arg1761z00_2710),
														BGl_globalz00zzast_varz00);
													BgL_test2238z00_3528 = BgL_res2063z00_2711;
												}
											}
											if (BgL_test2238z00_3528)
												{	/* Ast/check_type.scm 123 */
													if (
														((((BgL_globalz00_bglt) COBJECT(
																		((BgL_globalz00_bglt)
																			(((BgL_varz00_bglt) COBJECT(
																						((BgL_varz00_bglt)
																							BgL_nodez00_2541)))->
																				BgL_variablez00))))->BgL_importz00) ==
															CNST_TABLE_REF(((long) 2))))
														{	/* Ast/check_type.scm 124 */
															BgL_test2236z00_3523 = ((bool_t) 0);
														}
													else
														{	/* Ast/check_type.scm 124 */
															BgL_test2236z00_3523 = ((bool_t) 1);
														}
												}
											else
												{	/* Ast/check_type.scm 123 */
													BgL_test2236z00_3523 = ((bool_t) 0);
												}
										}
									else
										{	/* Ast/check_type.scm 122 */
											BgL_test2236z00_3523 = ((bool_t) 0);
										}
								}
								if (BgL_test2236z00_3523)
									{	/* Ast/check_type.scm 122 */
										return
											BGl_errzd2nozd2typez00zzast_checkzd2typezd2(
											((BgL_nodez00_bglt)
												((BgL_varz00_bglt) BgL_nodez00_2541)));
									}
								else
									{	/* Ast/check_type.scm 122 */
										return BFALSE;
									}
							}
						}
				}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_checkzd2typezd2()
	{
		{	/* Ast/check_type.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 116865673),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zztvector_tvectorz00(((long) 501518119),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			BGl_modulezd2initializa7ationz75zzmodule_includez00(((long) 184800657),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
			return
				BGl_modulezd2initializa7ationz75zzmodule_classz00(((long) 153808441),
				BSTRING_TO_STRING(BGl_string2112z00zzast_checkzd2typezd2));
		}

	}

#ifdef __cplusplus
}
#endif
