/*===========================================================================*/
/*   (Callcc/walk.scm)                                                       */
/*   Bigloo (4.3h)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 11 May 2020 12:14:39 PM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3h -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Callcc/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_localzf2cellzf2_bgl
	{
	}                      *BgL_localzf2cellzf2_bglt;


	static BgL_nodez00_bglt
		BGl_z62callccz12zd2sequence1320za2zzcallcc_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62callccz12z70zzcallcc_walkz00(obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_callccza2z12zb0zzcallcc_walkz00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzcallcc_walkz00();
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2conditional1336za2zzcallcc_walkz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_callcczd2walkz12zc0zzcallcc_walkz00(obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcallcc_walkz00();
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2appzd2ly1326z70zzcallcc_walkz00(obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2typez00zztype_cachez00(BgL_typez00_bglt);
	static obj_t BGl_localzf2cellzf2zzcallcc_walkz00 = BUNSPEC;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_cellzd2formalszd2zzcallcc_walkz00(obj_t,
		BgL_nodez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2extern1330za2zzcallcc_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_callccz12z12zzcallcc_walkz00(BgL_nodez00_bglt);
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2setzd2exzd2it1346za2zzcallcc_walkz00(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2funcall1328za2zzcallcc_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62callccz12zd2cast1332za2zzcallcc_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62callccz12zd2setq1334za2zzcallcc_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62callcczd2walkz12za2zzcallcc_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzcallcc_walkz00();
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2boxzd2ref1352z70zzcallcc_walkz00(obj_t, obj_t);
	static bool_t BGl_callcczd2funz12zc0zzcallcc_walkz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2boxzd2setz121354z62zzcallcc_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2makezd2box1350z70zzcallcc_walkz00(obj_t, obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_localz00_bglt BGl_z62lambda1652z62zzcallcc_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_localz00_bglt BGl_z62lambda1656z62zzcallcc_walkz00(obj_t, obj_t);
	static BgL_localz00_bglt BGl_z62lambda1660z62zzcallcc_walkz00(obj_t, obj_t);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00(BgL_typez00_bglt);
	static obj_t BGl_z62zc3z04anonymousza31659ze3ze5zzcallcc_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62callccz12zd2app1324za2zzcallcc_walkz00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcallcc_walkz00 = BUNSPEC;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzcallcc_walkz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcallcc_walkz00();
	static BgL_nodez00_bglt BGl_z62callccz12zd2atom1314za2zzcallcc_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_za2cellza2z00zztype_cachez00;
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_typez00zztype_typez00;
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2letzd2fun1342z70zzcallcc_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62callccz121311z70zzcallcc_walkz00(obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static bool_t BGl_celledzf3zf3zzcallcc_walkz00(BgL_variablez00_bglt);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2switch1340za2zzcallcc_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62callccz12zd2kwote1316za2zzcallcc_walkz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzcallcc_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcallcc_walkz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcallcc_walkz00();
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2letzd2var1344z70zzcallcc_walkz00(obj_t, obj_t);
	extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t,
		BgL_typez00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzcallcc_walkz00();
	static BgL_nodez00_bglt BGl_z62callccz12zd2sync1322za2zzcallcc_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62callccz12zd2fail1338za2zzcallcc_walkz00(obj_t,
		obj_t);
	static obj_t BGl_celledzd2bindingszd2zzcallcc_walkz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_valuez00zzast_varz00;
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static BgL_makezd2boxzd2_bglt
		BGl_azd2makezd2cellz00zzcallcc_walkz00(BgL_nodez00_bglt,
		BgL_variablez00_bglt);
	static BgL_nodez00_bglt BGl_z62callccz12zd2var1318za2zzcallcc_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62callccz12zd2jumpzd2exzd2it1348za2zzcallcc_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t __cnst[9];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1915z00zzcallcc_walkz00,
		BgL_bgl_za762lambda1660za7621949z00, BGl_z62lambda1660z62zzcallcc_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1916z00zzcallcc_walkz00,
		BgL_bgl_za762za7c3za704anonymo1950za7,
		BGl_z62zc3z04anonymousza31659ze3ze5zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1917z00zzcallcc_walkz00,
		BgL_bgl_za762lambda1656za7621951z00, BGl_z62lambda1656z62zzcallcc_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1918z00zzcallcc_walkz00,
		BgL_bgl_za762lambda1652za7621952z00, BGl_z62lambda1652z62zzcallcc_walkz00,
		0L, BUNSPEC, 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1919z00zzcallcc_walkz00,
		BgL_bgl_za762callccza71213111953z00,
		BGl_z62callccz121311z70zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1922z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2a1954za7,
		BGl_z62callccz12zd2atom1314za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1924z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2k1955za7,
		BGl_z62callccz12zd2kwote1316za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1925z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2v1956za7,
		BGl_z62callccz12zd2var1318za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1926z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2s1957za7,
		BGl_z62callccz12zd2sequence1320za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1927z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2s1958za7,
		BGl_z62callccz12zd2sync1322za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1928z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2a1959za7,
		BGl_z62callccz12zd2app1324za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1929z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2a1960za7,
		BGl_z62callccz12zd2appzd2ly1326z70zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1930z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2f1961za7,
		BGl_z62callccz12zd2funcall1328za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1931z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2e1962za7,
		BGl_z62callccz12zd2extern1330za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1932z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2c1963za7,
		BGl_z62callccz12zd2cast1332za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1933z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2s1964za7,
		BGl_z62callccz12zd2setq1334za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1934z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2c1965za7,
		BGl_z62callccz12zd2conditional1336za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1935z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2f1966za7,
		BGl_z62callccz12zd2fail1338za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1936z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2s1967za7,
		BGl_z62callccz12zd2switch1340za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1937z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2l1968za7,
		BGl_z62callccz12zd2letzd2fun1342z70zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1938z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2l1969za7,
		BGl_z62callccz12zd2letzd2var1344z70zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1939z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2s1970za7,
		BGl_z62callccz12zd2setzd2exzd2it1346za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1940z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2j1971za7,
		BGl_z62callccz12zd2jumpzd2exzd2it1348za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1941z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2m1972za7,
		BGl_z62callccz12zd2makezd2box1350z70zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1942z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2b1973za7,
		BGl_z62callccz12zd2boxzd2ref1352z70zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1943z00zzcallcc_walkz00,
		BgL_bgl_za762callccza712za7d2b1974za7,
		BGl_z62callccz12zd2boxzd2setz121354z62zzcallcc_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_callcczd2walkz12zd2envz12zzcallcc_walkz00,
		BgL_bgl_za762callccza7d2walk1975z00,
		BGl_z62callcczd2walkz12za2zzcallcc_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1907z00zzcallcc_walkz00,
		BgL_bgl_string1907za700za7za7c1976za7, "Callcc", 6);
	      DEFINE_STRING(BGl_string1908z00zzcallcc_walkz00,
		BgL_bgl_string1908za700za7za7c1977za7, "   . ", 5);
	      DEFINE_STRING(BGl_string1909z00zzcallcc_walkz00,
		BgL_bgl_string1909za700za7za7c1978za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string1910z00zzcallcc_walkz00,
		BgL_bgl_string1910za700za7za7c1979za7, " error", 6);
	      DEFINE_STRING(BGl_string1911z00zzcallcc_walkz00,
		BgL_bgl_string1911za700za7za7c1980za7, "s", 1);
	      DEFINE_STRING(BGl_string1912z00zzcallcc_walkz00,
		BgL_bgl_string1912za700za7za7c1981za7, "", 0);
	      DEFINE_STRING(BGl_string1913z00zzcallcc_walkz00,
		BgL_bgl_string1913za700za7za7c1982za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string1914z00zzcallcc_walkz00,
		BgL_bgl_string1914za700za7za7c1983za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string1920z00zzcallcc_walkz00,
		BgL_bgl_string1920za700za7za7c1984za7, "callcc!1311", 11);
	      DEFINE_STRING(BGl_string1921z00zzcallcc_walkz00,
		BgL_bgl_string1921za700za7za7c1985za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string1923z00zzcallcc_walkz00,
		BgL_bgl_string1923za700za7za7c1986za7, "callcc!", 7);
	      DEFINE_STRING(BGl_string1944z00zzcallcc_walkz00,
		BgL_bgl_string1944za700za7za7c1987za7, "callcc_walk", 11);
	      DEFINE_STRING(BGl_string1945z00zzcallcc_walkz00,
		BgL_bgl_string1945za700za7za7c1988za7,
		"aux callcc!1311 _ callcc_walk local/cell done write cell-callcc pass-started ",
		77);
	      DEFINE_STATIC_BGL_GENERIC(BGl_callccz12zd2envzc0zzcallcc_walkz00,
		BgL_bgl_za762callccza712za770za71989z00,
		BGl_z62callccz12z70zzcallcc_walkz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_localzf2cellzf2zzcallcc_walkz00));
		   
			 ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzcallcc_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcallcc_walkz00(long
		BgL_checksumz00_2437, char *BgL_fromz00_2438)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcallcc_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzcallcc_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcallcc_walkz00();
					BGl_libraryzd2moduleszd2initz00zzcallcc_walkz00();
					BGl_cnstzd2initzd2zzcallcc_walkz00();
					BGl_importedzd2moduleszd2initz00zzcallcc_walkz00();
					BGl_objectzd2initzd2zzcallcc_walkz00();
					BGl_genericzd2initzd2zzcallcc_walkz00();
					BGl_methodzd2initzd2zzcallcc_walkz00();
					return BGl_toplevelzd2initzd2zzcallcc_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"callcc_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "callcc_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"callcc_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"callcc_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"callcc_walk");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			{	/* Callcc/walk.scm 16 */
				obj_t BgL_cportz00_2291;

				{	/* Callcc/walk.scm 16 */
					obj_t BgL_stringz00_2299;

					BgL_stringz00_2299 = BGl_string1945z00zzcallcc_walkz00;
					{	/* Callcc/walk.scm 16 */
						obj_t BgL_startz00_2300;

						BgL_startz00_2300 = BINT(((long) 0));
						{	/* Callcc/walk.scm 16 */
							obj_t BgL_endz00_2301;

							BgL_endz00_2301 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2299)));
							{	/* Callcc/walk.scm 16 */

								BgL_cportz00_2291 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2299, BgL_startz00_2300, BgL_endz00_2301);
				}}}}
				{
					long BgL_iz00_2292;

					BgL_iz00_2292 = ((long) 8);
				BgL_loopz00_2293:
					if ((BgL_iz00_2292 == ((long) -1)))
						{	/* Callcc/walk.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Callcc/walk.scm 16 */
							{	/* Callcc/walk.scm 16 */
								obj_t BgL_arg1947z00_2295;

								{	/* Callcc/walk.scm 16 */

									{	/* Callcc/walk.scm 16 */
										obj_t BgL_locationz00_2297;

										BgL_locationz00_2297 = BBOOL(((bool_t) 0));
										{	/* Callcc/walk.scm 16 */

											BgL_arg1947z00_2295 =
												BGl_readz00zz__readerz00(BgL_cportz00_2291,
												BgL_locationz00_2297);
										}
									}
								}
								{	/* Callcc/walk.scm 16 */
									int BgL_tmpz00_2470;

									BgL_tmpz00_2470 = (int) (BgL_iz00_2292);
									CNST_TABLE_SET(BgL_tmpz00_2470, BgL_arg1947z00_2295);
							}}
							{	/* Callcc/walk.scm 16 */
								int BgL_auxz00_2298;

								BgL_auxz00_2298 = (int) ((BgL_iz00_2292 - ((long) 1)));
								{
									long BgL_iz00_2475;

									BgL_iz00_2475 = (long) (BgL_auxz00_2298);
									BgL_iz00_2292 = BgL_iz00_2475;
									goto BgL_loopz00_2293;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			return BUNSPEC;
		}

	}



/* callcc-walk! */
	BGL_EXPORTED_DEF obj_t BGl_callcczd2walkz12zc0zzcallcc_walkz00(obj_t
		BgL_globalsz00_48)
	{
		{	/* Callcc/walk.scm 31 */
			{	/* Callcc/walk.scm 32 */
				obj_t BgL_list1380z00_1378;

				{	/* Callcc/walk.scm 32 */
					obj_t BgL_arg1406z00_1379;

					{	/* Callcc/walk.scm 32 */
						obj_t BgL_arg1407z00_1380;

						BgL_arg1407z00_1380 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1406z00_1379 =
							MAKE_YOUNG_PAIR(BGl_string1907z00zzcallcc_walkz00,
							BgL_arg1407z00_1380);
					}
					BgL_list1380z00_1378 =
						MAKE_YOUNG_PAIR(BGl_string1908z00zzcallcc_walkz00,
						BgL_arg1406z00_1379);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1380z00_1378);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string1907z00zzcallcc_walkz00;
			{	/* Callcc/walk.scm 32 */
				obj_t BgL_g1126z00_1381;

				BgL_g1126z00_1381 = BNIL;
				{
					obj_t BgL_hooksz00_1384;
					obj_t BgL_hnamesz00_1385;

					BgL_hooksz00_1384 = BgL_g1126z00_1381;
					BgL_hnamesz00_1385 = BNIL;
				BgL_zc3z04anonymousza31408ze3z87_1386:
					if (NULLP(BgL_hooksz00_1384))
						{	/* Callcc/walk.scm 32 */
							CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Callcc/walk.scm 32 */
							bool_t BgL_test1993z00_2488;

							{	/* Callcc/walk.scm 32 */
								obj_t BgL_fun1430z00_1393;

								BgL_fun1430z00_1393 = CAR(((obj_t) BgL_hooksz00_1384));
								BgL_test1993z00_2488 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1430z00_1393)
									(BgL_fun1430z00_1393, BEOA));
							}
							if (BgL_test1993z00_2488)
								{	/* Callcc/walk.scm 32 */
									obj_t BgL_arg1421z00_1390;
									obj_t BgL_arg1422z00_1391;

									BgL_arg1421z00_1390 = CDR(((obj_t) BgL_hooksz00_1384));
									BgL_arg1422z00_1391 = CDR(((obj_t) BgL_hnamesz00_1385));
									{
										obj_t BgL_hnamesz00_2500;
										obj_t BgL_hooksz00_2499;

										BgL_hooksz00_2499 = BgL_arg1421z00_1390;
										BgL_hnamesz00_2500 = BgL_arg1422z00_1391;
										BgL_hnamesz00_1385 = BgL_hnamesz00_2500;
										BgL_hooksz00_1384 = BgL_hooksz00_2499;
										goto BgL_zc3z04anonymousza31408ze3z87_1386;
									}
								}
							else
								{	/* Callcc/walk.scm 32 */
									obj_t BgL_arg1429z00_1392;

									BgL_arg1429z00_1392 = CAR(((obj_t) BgL_hnamesz00_1385));
									BGl_internalzd2errorzd2zztools_errorz00
										(BGl_string1907z00zzcallcc_walkz00,
										BGl_string1909z00zzcallcc_walkz00, BgL_arg1429z00_1392);
								}
						}
				}
			}
			if (
				((long) CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >=
					((long) 2)))
				{	/* Callcc/walk.scm 34 */
					BGl_za2compilerzd2debugza2zd2zzengine_paramz00 = BINT(((long) 1));
				}
			else
				{	/* Callcc/walk.scm 34 */
					BFALSE;
				}
			{
				obj_t BgL_l1288z00_1398;

				BgL_l1288z00_1398 = BgL_globalsz00_48;
			BgL_zc3z04anonymousza31433ze3z87_1399:
				if (PAIRP(BgL_l1288z00_1398))
					{	/* Callcc/walk.scm 36 */
						BGl_callcczd2funz12zc0zzcallcc_walkz00(CAR(BgL_l1288z00_1398));
						{
							obj_t BgL_l1288z00_2512;

							BgL_l1288z00_2512 = CDR(BgL_l1288z00_1398);
							BgL_l1288z00_1398 = BgL_l1288z00_2512;
							goto BgL_zc3z04anonymousza31433ze3z87_1399;
						}
					}
				else
					{	/* Callcc/walk.scm 36 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Callcc/walk.scm 37 */
					{	/* Callcc/walk.scm 37 */
						obj_t BgL_port1290z00_1406;

						{	/* Callcc/walk.scm 37 */
							obj_t BgL_res1856z00_1950;

							{	/* Callcc/walk.scm 37 */
								obj_t BgL_tmpz00_2517;

								BgL_tmpz00_2517 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1856z00_1950 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_2517);
							}
							BgL_port1290z00_1406 = BgL_res1856z00_1950;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1290z00_1406);
						bgl_display_string(BGl_string1910z00zzcallcc_walkz00,
							BgL_port1290z00_1406);
						{	/* Callcc/walk.scm 37 */
							obj_t BgL_arg1466z00_1407;

							{	/* Callcc/walk.scm 37 */
								bool_t BgL_test1997z00_2522;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Callcc/walk.scm 37 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Callcc/walk.scm 37 */
												BgL_test1997z00_2522 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Callcc/walk.scm 37 */
												BgL_test1997z00_2522 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Callcc/walk.scm 37 */
										BgL_test1997z00_2522 = ((bool_t) 0);
									}
								if (BgL_test1997z00_2522)
									{	/* Callcc/walk.scm 37 */
										BgL_arg1466z00_1407 = BGl_string1911z00zzcallcc_walkz00;
									}
								else
									{	/* Callcc/walk.scm 37 */
										BgL_arg1466z00_1407 = BGl_string1912z00zzcallcc_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1466z00_1407, BgL_port1290z00_1406);
						}
						bgl_display_string(BGl_string1913z00zzcallcc_walkz00,
							BgL_port1290z00_1406);
						bgl_display_char(((unsigned char) 10), BgL_port1290z00_1406);
					}
					{	/* Callcc/walk.scm 37 */
						obj_t BgL_list1470z00_1413;

						BgL_list1470z00_1413 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1470z00_1413);
					}
				}
			else
				{	/* Callcc/walk.scm 37 */
					obj_t BgL_g1129z00_1414;

					BgL_g1129z00_1414 = BNIL;
					{
						obj_t BgL_hooksz00_1417;
						obj_t BgL_hnamesz00_1418;

						BgL_hooksz00_1417 = BgL_g1129z00_1414;
						BgL_hnamesz00_1418 = BNIL;
					BgL_zc3z04anonymousza31471ze3z87_1419:
						if (NULLP(BgL_hooksz00_1417))
							{	/* Callcc/walk.scm 37 */
								return BgL_globalsz00_48;
							}
						else
							{	/* Callcc/walk.scm 37 */
								bool_t BgL_test2001z00_2539;

								{	/* Callcc/walk.scm 37 */
									obj_t BgL_fun1493z00_1426;

									BgL_fun1493z00_1426 = CAR(((obj_t) BgL_hooksz00_1417));
									BgL_test2001z00_2539 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1493z00_1426)
										(BgL_fun1493z00_1426, BEOA));
								}
								if (BgL_test2001z00_2539)
									{	/* Callcc/walk.scm 37 */
										obj_t BgL_arg1488z00_1423;
										obj_t BgL_arg1490z00_1424;

										BgL_arg1488z00_1423 = CDR(((obj_t) BgL_hooksz00_1417));
										BgL_arg1490z00_1424 = CDR(((obj_t) BgL_hnamesz00_1418));
										{
											obj_t BgL_hnamesz00_2551;
											obj_t BgL_hooksz00_2550;

											BgL_hooksz00_2550 = BgL_arg1488z00_1423;
											BgL_hnamesz00_2551 = BgL_arg1490z00_1424;
											BgL_hnamesz00_1418 = BgL_hnamesz00_2551;
											BgL_hooksz00_1417 = BgL_hooksz00_2550;
											goto BgL_zc3z04anonymousza31471ze3z87_1419;
										}
									}
								else
									{	/* Callcc/walk.scm 37 */
										obj_t BgL_arg1492z00_1425;

										BgL_arg1492z00_1425 = CAR(((obj_t) BgL_hnamesz00_1418));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string1914z00zzcallcc_walkz00, BgL_arg1492z00_1425);
									}
							}
					}
				}
		}

	}



/* &callcc-walk! */
	obj_t BGl_z62callcczd2walkz12za2zzcallcc_walkz00(obj_t BgL_envz00_2199,
		obj_t BgL_globalsz00_2200)
	{
		{	/* Callcc/walk.scm 31 */
			return BGl_callcczd2walkz12zc0zzcallcc_walkz00(BgL_globalsz00_2200);
		}

	}



/* callcc-fun! */
	bool_t BGl_callcczd2funz12zc0zzcallcc_walkz00(obj_t BgL_varz00_49)
	{
		{	/* Callcc/walk.scm 42 */
			{	/* Callcc/walk.scm 43 */
				BgL_valuez00_bglt BgL_funz00_1429;

				BgL_funz00_1429 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_varz00_49)))->BgL_valuez00);
				{	/* Callcc/walk.scm 43 */
					obj_t BgL_bodyz00_1430;

					BgL_bodyz00_1430 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_funz00_1429)))->BgL_bodyz00);
					{	/* Callcc/walk.scm 44 */
						obj_t BgL_celledz00_1431;

						{	/* Callcc/walk.scm 45 */
							obj_t BgL_arg1524z00_1451;

							BgL_arg1524z00_1451 =
								(((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt) BgL_funz00_1429)))->BgL_argsz00);
							BgL_celledz00_1431 =
								BGl_celledzd2bindingszd2zzcallcc_walkz00(BgL_arg1524z00_1451);
						}
						{	/* Callcc/walk.scm 45 */

							{
								obj_t BgL_l1291z00_1433;

								BgL_l1291z00_1433 = BgL_celledz00_1431;
							BgL_zc3z04anonymousza31495ze3z87_1434:
								if (PAIRP(BgL_l1291z00_1433))
									{	/* Callcc/walk.scm 47 */
										{	/* Callcc/walk.scm 48 */
											obj_t BgL_wzd2bzd2_1436;

											BgL_wzd2bzd2_1436 = CAR(BgL_l1291z00_1433);
											{	/* Callcc/walk.scm 48 */
												obj_t BgL_arg1502z00_1437;
												obj_t BgL_arg1503z00_1438;

												BgL_arg1502z00_1437 = CAR(((obj_t) BgL_wzd2bzd2_1436));
												BgL_arg1503z00_1438 = CDR(((obj_t) BgL_wzd2bzd2_1436));
												((((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_arg1502z00_1437))))->
														BgL_fastzd2alphazd2) =
													((obj_t) BgL_arg1503z00_1438), BUNSPEC);
											}
										}
										{
											obj_t BgL_l1291z00_2573;

											BgL_l1291z00_2573 = CDR(BgL_l1291z00_1433);
											BgL_l1291z00_1433 = BgL_l1291z00_2573;
											goto BgL_zc3z04anonymousza31495ze3z87_1434;
										}
									}
								else
									{	/* Callcc/walk.scm 47 */
										((bool_t) 1);
									}
							}
							{	/* Callcc/walk.scm 50 */
								BgL_nodez00_bglt BgL_arg1512z00_1441;

								{	/* Callcc/walk.scm 50 */
									BgL_nodez00_bglt BgL_arg1514z00_1442;

									BgL_arg1514z00_1442 =
										BGl_callccz12z12zzcallcc_walkz00(
										((BgL_nodez00_bglt) BgL_bodyz00_1430));
									BgL_arg1512z00_1441 =
										BGl_cellzd2formalszd2zzcallcc_walkz00(BgL_celledz00_1431,
										BgL_arg1514z00_1442);
								}
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_funz00_1429)))->BgL_bodyz00) =
									((obj_t) ((obj_t) BgL_arg1512z00_1441)), BUNSPEC);
							}
							{
								obj_t BgL_l1293z00_1444;

								BgL_l1293z00_1444 = BgL_celledz00_1431;
							BgL_zc3z04anonymousza31515ze3z87_1445:
								if (PAIRP(BgL_l1293z00_1444))
									{	/* Callcc/walk.scm 52 */
										{	/* Callcc/walk.scm 53 */
											obj_t BgL_wzd2bzd2_1447;

											BgL_wzd2bzd2_1447 = CAR(BgL_l1293z00_1444);
											{	/* Callcc/walk.scm 53 */
												obj_t BgL_arg1518z00_1448;

												BgL_arg1518z00_1448 = CAR(((obj_t) BgL_wzd2bzd2_1447));
												((((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_arg1518z00_1448))))->
														BgL_fastzd2alphazd2) = ((obj_t) BUNSPEC), BUNSPEC);
											}
										}
										{
											obj_t BgL_l1293z00_2589;

											BgL_l1293z00_2589 = CDR(BgL_l1293z00_1444);
											BgL_l1293z00_1444 = BgL_l1293z00_2589;
											goto BgL_zc3z04anonymousza31515ze3z87_1445;
										}
									}
								else
									{	/* Callcc/walk.scm 52 */
										return ((bool_t) 1);
									}
							}
						}
					}
				}
			}
		}

	}



/* celled-bindings */
	obj_t BGl_celledzd2bindingszd2zzcallcc_walkz00(obj_t BgL_formalsz00_50)
	{
		{	/* Callcc/walk.scm 59 */
			{
				obj_t BgL_celledz00_1454;
				obj_t BgL_formalsz00_1455;

				BgL_celledz00_1454 = BNIL;
				BgL_formalsz00_1455 = BgL_formalsz00_50;
			BgL_zc3z04anonymousza31525ze3z87_1456:
				if (NULLP(BgL_formalsz00_1455))
					{	/* Callcc/walk.scm 63 */
						return BgL_celledz00_1454;
					}
				else
					{	/* Callcc/walk.scm 65 */
						bool_t BgL_test2005z00_2593;

						{	/* Callcc/walk.scm 65 */
							obj_t BgL_arg1564z00_1478;

							BgL_arg1564z00_1478 = CAR(((obj_t) BgL_formalsz00_1455));
							BgL_test2005z00_2593 =
								BGl_celledzf3zf3zzcallcc_walkz00(
								((BgL_variablez00_bglt) BgL_arg1564z00_1478));
						}
						if (BgL_test2005z00_2593)
							{	/* Callcc/walk.scm 68 */
								BgL_typez00_bglt BgL_vtypez00_1460;

								BgL_vtypez00_1460 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_localz00_bglt)
													CAR(((obj_t) BgL_formalsz00_1455))))))->BgL_typez00);
								{	/* Callcc/walk.scm 68 */
									obj_t BgL_ntypez00_1461;

									if (
										(((obj_t) BgL_vtypez00_1460) ==
											BGl_za2_za2z00zztype_cachez00))
										{	/* Callcc/walk.scm 70 */
											BgL_ntypez00_1461 = BGl_za2objza2z00zztype_cachez00;
										}
									else
										{	/* Callcc/walk.scm 70 */
											if (BGl_bigloozd2typezf3z21zztype_typez00
												(BgL_vtypez00_1460))
												{	/* Callcc/walk.scm 71 */
													BgL_ntypez00_1461 = ((obj_t) BgL_vtypez00_1460);
												}
											else
												{	/* Callcc/walk.scm 71 */
													BgL_ntypez00_1461 =
														((obj_t)
														BGl_getzd2bigloozd2typez00zztype_cachez00
														(BgL_vtypez00_1460));
												}
										}
									{	/* Callcc/walk.scm 69 */
										BgL_localz00_bglt BgL_varz00_1462;

										{	/* Callcc/walk.scm 73 */
											obj_t BgL_arg1547z00_1472;

											BgL_arg1547z00_1472 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(
																	((obj_t) BgL_formalsz00_1455))))))->
												BgL_idz00);
											BgL_varz00_1462 =
												BGl_makezd2localzd2svarz00zzast_localz00
												(BgL_arg1547z00_1472,
												((BgL_typez00_bglt) BGl_za2cellza2z00zztype_cachez00));
										}
										{	/* Callcc/walk.scm 73 */
											obj_t BgL_ozd2nzd2_1463;

											{	/* Callcc/walk.scm 74 */
												obj_t BgL_arg1544z00_1471;

												BgL_arg1544z00_1471 =
													CAR(((obj_t) BgL_formalsz00_1455));
												BgL_ozd2nzd2_1463 =
													MAKE_YOUNG_PAIR(BgL_arg1544z00_1471,
													((obj_t) BgL_varz00_1462));
											}
											{	/* Callcc/walk.scm 74 */

												{	/* Callcc/walk.scm 75 */
													BgL_localzf2cellzf2_bglt BgL_wide1137z00_1466;

													BgL_wide1137z00_1466 =
														((BgL_localzf2cellzf2_bglt)
														BOBJECT(GC_MALLOC(sizeof(struct
																	BgL_localzf2cellzf2_bgl))));
													{	/* Callcc/walk.scm 75 */
														obj_t BgL_auxz00_2626;
														BgL_objectz00_bglt BgL_tmpz00_2623;

														BgL_auxz00_2626 = ((obj_t) BgL_wide1137z00_1466);
														BgL_tmpz00_2623 =
															((BgL_objectz00_bglt)
															((BgL_localz00_bglt) BgL_varz00_1462));
														BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2623,
															BgL_auxz00_2626);
													}
													((BgL_objectz00_bglt)
														((BgL_localz00_bglt) BgL_varz00_1462));
													{	/* Callcc/walk.scm 75 */
														long BgL_arg1531z00_1467;

														{	/* Callcc/walk.scm 75 */
															long BgL_res1864z00_1990;

															BgL_res1864z00_1990 =
																BGL_CLASS_INDEX
																(BGl_localzf2cellzf2zzcallcc_walkz00);
															BgL_arg1531z00_1467 = BgL_res1864z00_1990;
														}
														BGL_OBJECT_CLASS_NUM_SET(
															((BgL_objectz00_bglt)
																((BgL_localz00_bglt) BgL_varz00_1462)),
															BgL_arg1531z00_1467);
													}
													((BgL_localz00_bglt)
														((BgL_localz00_bglt) BgL_varz00_1462));
												}
												((BgL_localz00_bglt) BgL_varz00_1462);
												{	/* Callcc/walk.scm 76 */
													obj_t BgL_arg1540z00_1469;
													obj_t BgL_arg1543z00_1470;

													BgL_arg1540z00_1469 =
														MAKE_YOUNG_PAIR(BgL_ozd2nzd2_1463,
														BgL_celledz00_1454);
													BgL_arg1543z00_1470 =
														CDR(((obj_t) BgL_formalsz00_1455));
													{
														obj_t BgL_formalsz00_2642;
														obj_t BgL_celledz00_2641;

														BgL_celledz00_2641 = BgL_arg1540z00_1469;
														BgL_formalsz00_2642 = BgL_arg1543z00_1470;
														BgL_formalsz00_1455 = BgL_formalsz00_2642;
														BgL_celledz00_1454 = BgL_celledz00_2641;
														goto BgL_zc3z04anonymousza31525ze3z87_1456;
													}
												}
											}
										}
									}
								}
							}
						else
							{	/* Callcc/walk.scm 66 */
								obj_t BgL_arg1562z00_1477;

								BgL_arg1562z00_1477 = CDR(((obj_t) BgL_formalsz00_1455));
								{
									obj_t BgL_formalsz00_2645;

									BgL_formalsz00_2645 = BgL_arg1562z00_1477;
									BgL_formalsz00_1455 = BgL_formalsz00_2645;
									goto BgL_zc3z04anonymousza31525ze3z87_1456;
								}
							}
					}
			}
		}

	}



/* cell-formals */
	BgL_nodez00_bglt BGl_cellzd2formalszd2zzcallcc_walkz00(obj_t BgL_celledz00_51,
		BgL_nodez00_bglt BgL_bodyz00_52)
	{
		{	/* Callcc/walk.scm 81 */
			if (NULLP(BgL_celledz00_51))
				{	/* Callcc/walk.scm 82 */
					return BgL_bodyz00_52;
				}
			else
				{	/* Callcc/walk.scm 84 */
					obj_t BgL_locz00_1481;

					BgL_locz00_1481 =
						(((BgL_nodez00_bglt) COBJECT(BgL_bodyz00_52))->BgL_locz00);
					{	/* Callcc/walk.scm 85 */
						BgL_letzd2varzd2_bglt BgL_new1140z00_1482;

						{	/* Callcc/walk.scm 86 */
							BgL_letzd2varzd2_bglt BgL_new1139z00_1504;

							BgL_new1139z00_1504 =
								((BgL_letzd2varzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_letzd2varzd2_bgl))));
							{	/* Callcc/walk.scm 86 */
								long BgL_arg1608z00_1505;

								{	/* Callcc/walk.scm 86 */
									long BgL_res1866z00_1998;

									BgL_res1866z00_1998 =
										BGL_CLASS_INDEX(BGl_letzd2varzd2zzast_nodez00);
									BgL_arg1608z00_1505 = BgL_res1866z00_1998;
								}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1139z00_1504),
									BgL_arg1608z00_1505);
							}
							{	/* Callcc/walk.scm 86 */
								BgL_objectz00_bglt BgL_tmpz00_2653;

								BgL_tmpz00_2653 = ((BgL_objectz00_bglt) BgL_new1139z00_1504);
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2653, BFALSE);
							}
							((BgL_objectz00_bglt) BgL_new1139z00_1504);
							BgL_new1140z00_1482 = BgL_new1139z00_1504;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1140z00_1482)))->BgL_locz00) =
							((obj_t) BgL_locz00_1481), BUNSPEC);
						((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
											BgL_new1140z00_1482)))->BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT(BgL_bodyz00_52))->BgL_typez00)), BUNSPEC);
						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
											BgL_new1140z00_1482)))->BgL_sidezd2effectzd2) =
							((obj_t) BUNSPEC), BUNSPEC);
						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
											BgL_new1140z00_1482)))->BgL_keyz00) =
							((obj_t) BINT(((long) -1))), BUNSPEC);
						{
							obj_t BgL_auxz00_2667;

							{	/* Callcc/walk.scm 89 */
								obj_t BgL_l1295z00_1483;

								BgL_l1295z00_1483 = BgL_celledz00_51;
								if (NULLP(BgL_l1295z00_1483))
									{	/* Callcc/walk.scm 89 */
										BgL_auxz00_2667 = BNIL;
									}
								else
									{	/* Callcc/walk.scm 89 */
										obj_t BgL_head1297z00_1485;

										{	/* Callcc/walk.scm 89 */
											obj_t BgL_res1868z00_2004;

											BgL_res1868z00_2004 = MAKE_YOUNG_PAIR(BNIL, BNIL);
											BgL_head1297z00_1485 = BgL_res1868z00_2004;
										}
										{
											obj_t BgL_l1295z00_1487;
											obj_t BgL_tail1298z00_1488;

											BgL_l1295z00_1487 = BgL_l1295z00_1483;
											BgL_tail1298z00_1488 = BgL_head1297z00_1485;
										BgL_zc3z04anonymousza31568ze3z87_1489:
											if (NULLP(BgL_l1295z00_1487))
												{	/* Callcc/walk.scm 89 */
													BgL_auxz00_2667 = CDR(BgL_head1297z00_1485);
												}
											else
												{	/* Callcc/walk.scm 89 */
													obj_t BgL_newtail1299z00_1491;

													{	/* Callcc/walk.scm 89 */
														obj_t BgL_arg1578z00_1493;

														{	/* Callcc/walk.scm 89 */
															obj_t BgL_ozd2nzd2_1494;

															BgL_ozd2nzd2_1494 =
																CAR(((obj_t) BgL_l1295z00_1487));
															{	/* Callcc/walk.scm 90 */
																obj_t BgL_arg1579z00_1495;
																BgL_makezd2boxzd2_bglt BgL_arg1582z00_1496;

																BgL_arg1579z00_1495 =
																	CDR(((obj_t) BgL_ozd2nzd2_1494));
																{	/* Callcc/walk.scm 92 */
																	BgL_varz00_bglt BgL_arg1588z00_1497;
																	obj_t BgL_arg1594z00_1498;

																	{	/* Callcc/walk.scm 92 */
																		BgL_varz00_bglt BgL_new1142z00_1499;

																		{	/* Callcc/walk.scm 95 */
																			BgL_varz00_bglt BgL_new1141z00_1501;

																			BgL_new1141z00_1501 =
																				((BgL_varz00_bglt)
																				BOBJECT(GC_MALLOC(sizeof(struct
																							BgL_varz00_bgl))));
																			{	/* Callcc/walk.scm 95 */
																				long BgL_arg1600z00_1502;

																				{	/* Callcc/walk.scm 95 */
																					long BgL_res1870z00_2010;

																					{	/* Callcc/walk.scm 95 */
																						obj_t BgL_classz00_2009;

																						BgL_classz00_2009 =
																							BGl_varz00zzast_nodez00;
																						BgL_res1870z00_2010 =
																							BGL_CLASS_INDEX
																							(BgL_classz00_2009);
																					}
																					BgL_arg1600z00_1502 =
																						BgL_res1870z00_2010;
																				}
																				BGL_OBJECT_CLASS_NUM_SET(
																					((BgL_objectz00_bglt)
																						BgL_new1141z00_1501),
																					BgL_arg1600z00_1502);
																			}
																			BgL_new1142z00_1499 = BgL_new1141z00_1501;
																		}
																		((((BgL_nodez00_bglt) COBJECT(
																						((BgL_nodez00_bglt)
																							BgL_new1142z00_1499)))->
																				BgL_locz00) =
																			((obj_t) BgL_locz00_1481), BUNSPEC);
																		((((BgL_nodez00_bglt)
																					COBJECT(((BgL_nodez00_bglt)
																							BgL_new1142z00_1499)))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) ((
																						(BgL_variablez00_bglt)
																						COBJECT(((BgL_variablez00_bglt)
																								CAR(((obj_t)
																										BgL_ozd2nzd2_1494)))))->
																					BgL_typez00)), BUNSPEC);
																		((((BgL_varz00_bglt)
																					COBJECT(BgL_new1142z00_1499))->
																				BgL_variablez00) =
																			((BgL_variablez00_bglt) (
																					(BgL_variablez00_bglt) CAR(((obj_t)
																							BgL_ozd2nzd2_1494)))), BUNSPEC);
																		BgL_arg1588z00_1497 = BgL_new1142z00_1499;
																	}
																	BgL_arg1594z00_1498 =
																		CAR(((obj_t) BgL_ozd2nzd2_1494));
																	BgL_arg1582z00_1496 =
																		BGl_azd2makezd2cellz00zzcallcc_walkz00(
																		((BgL_nodez00_bglt) BgL_arg1588z00_1497),
																		((BgL_variablez00_bglt)
																			BgL_arg1594z00_1498));
																}
																BgL_arg1578z00_1493 =
																	MAKE_YOUNG_PAIR(BgL_arg1579z00_1495,
																	((obj_t) BgL_arg1582z00_1496));
														}}
														{	/* Callcc/walk.scm 89 */
															obj_t BgL_res1871z00_2017;

															BgL_res1871z00_2017 =
																MAKE_YOUNG_PAIR(BgL_arg1578z00_1493, BNIL);
															BgL_newtail1299z00_1491 = BgL_res1871z00_2017;
													}}
													SET_CDR(BgL_tail1298z00_1488,
														BgL_newtail1299z00_1491);
													{	/* Callcc/walk.scm 89 */
														obj_t BgL_arg1572z00_1492;

														BgL_arg1572z00_1492 =
															CDR(((obj_t) BgL_l1295z00_1487));
														{
															obj_t BgL_tail1298z00_2706;
															obj_t BgL_l1295z00_2705;

															BgL_l1295z00_2705 = BgL_arg1572z00_1492;
															BgL_tail1298z00_2706 = BgL_newtail1299z00_1491;
															BgL_tail1298z00_1488 = BgL_tail1298z00_2706;
															BgL_l1295z00_1487 = BgL_l1295z00_2705;
															goto BgL_zc3z04anonymousza31568ze3z87_1489;
														}
													}
												}
										}
									}
							}
							((((BgL_letzd2varzd2_bglt) COBJECT(BgL_new1140z00_1482))->
									BgL_bindingsz00) = ((obj_t) BgL_auxz00_2667), BUNSPEC);
						}
						((((BgL_letzd2varzd2_bglt) COBJECT(BgL_new1140z00_1482))->
								BgL_bodyz00) = ((BgL_nodez00_bglt) BgL_bodyz00_52), BUNSPEC);
						((((BgL_letzd2varzd2_bglt) COBJECT(BgL_new1140z00_1482))->
								BgL_removablezf3zf3) = ((bool_t) ((bool_t) 1)), BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1140z00_1482);
					}
				}
		}

	}



/* a-make-cell */
	BgL_makezd2boxzd2_bglt BGl_azd2makezd2cellz00zzcallcc_walkz00(BgL_nodez00_bglt
		BgL_nodez00_53, BgL_variablez00_bglt BgL_variablez00_54)
	{
		{	/* Callcc/walk.scm 102 */
			{	/* Callcc/walk.scm 104 */
				obj_t BgL_vz00_2021;

				BgL_vz00_2021 = CNST_TABLE_REF(((long) 1));
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_variablez00_54))))->BgL_accessz00) =
					((obj_t) BgL_vz00_2021), BUNSPEC);
			}
			{	/* Callcc/walk.scm 105 */
				BgL_localzf2cellzf2_bglt BgL_wide1146z00_1509;

				BgL_wide1146z00_1509 =
					((BgL_localzf2cellzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_localzf2cellzf2_bgl))));
				{	/* Callcc/walk.scm 105 */
					obj_t BgL_auxz00_2720;
					BgL_objectz00_bglt BgL_tmpz00_2716;

					BgL_auxz00_2720 = ((obj_t) BgL_wide1146z00_1509);
					BgL_tmpz00_2716 =
						((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_variablez00_54)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2716, BgL_auxz00_2720);
				}
				((BgL_objectz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_variablez00_54)));
				{	/* Callcc/walk.scm 105 */
					long BgL_arg1610z00_1510;

					{	/* Callcc/walk.scm 105 */
						long BgL_res1872z00_2024;

						BgL_res1872z00_2024 =
							BGL_CLASS_INDEX(BGl_localzf2cellzf2zzcallcc_walkz00);
						BgL_arg1610z00_1510 = BgL_res1872z00_2024;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_localz00_bglt)
								((BgL_localz00_bglt) BgL_variablez00_54))),
						BgL_arg1610z00_1510);
				}
				((BgL_localz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_variablez00_54)));
			}
			((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_variablez00_54));
			{	/* Callcc/walk.scm 106 */
				BgL_makezd2boxzd2_bglt BgL_new1149z00_1512;

				{	/* Callcc/walk.scm 109 */
					BgL_makezd2boxzd2_bglt BgL_new1148z00_1514;

					BgL_new1148z00_1514 =
						((BgL_makezd2boxzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_makezd2boxzd2_bgl))));
					{	/* Callcc/walk.scm 109 */
						long BgL_arg1622z00_1515;

						{	/* Callcc/walk.scm 109 */
							long BgL_res1873z00_2028;

							BgL_res1873z00_2028 =
								BGL_CLASS_INDEX(BGl_makezd2boxzd2zzast_nodez00);
							BgL_arg1622z00_1515 = BgL_res1873z00_2028;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1148z00_1514), BgL_arg1622z00_1515);
					}
					{	/* Callcc/walk.scm 109 */
						BgL_objectz00_bglt BgL_tmpz00_2740;

						BgL_tmpz00_2740 = ((BgL_objectz00_bglt) BgL_new1148z00_1514);
						BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2740, BFALSE);
					}
					((BgL_objectz00_bglt) BgL_new1148z00_1514);
					BgL_new1149z00_1512 = BgL_new1148z00_1514;
				}
				((((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt) BgL_new1149z00_1512)))->BgL_locz00) =
					((obj_t) (((BgL_nodez00_bglt) COBJECT(BgL_nodez00_53))->BgL_locz00)),
					BUNSPEC);
				((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
									BgL_new1149z00_1512)))->BgL_typez00) =
					((BgL_typez00_bglt) ((BgL_typez00_bglt)
							BGl_za2cellza2z00zztype_cachez00)), BUNSPEC);
				((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
									BgL_new1149z00_1512)))->BgL_sidezd2effectzd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
									BgL_new1149z00_1512)))->BgL_keyz00) =
					((obj_t) BINT(((long) -1))), BUNSPEC);
				((((BgL_makezd2boxzd2_bglt) COBJECT(BgL_new1149z00_1512))->
						BgL_valuez00) = ((BgL_nodez00_bglt) BgL_nodez00_53), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_2756;

					{	/* Callcc/walk.scm 108 */
						BgL_typez00_bglt BgL_arg1614z00_1513;

						BgL_arg1614z00_1513 =
							(((BgL_variablez00_bglt) COBJECT(BgL_variablez00_54))->
							BgL_typez00);
						BgL_auxz00_2756 =
							BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
							(BgL_arg1614z00_1513);
					}
					((((BgL_makezd2boxzd2_bglt) COBJECT(BgL_new1149z00_1512))->
							BgL_vtypez00) = ((BgL_typez00_bglt) BgL_auxz00_2756), BUNSPEC);
				}
				return BgL_new1149z00_1512;
			}
		}

	}



/* celled? */
	bool_t BGl_celledzf3zf3zzcallcc_walkz00(BgL_variablez00_bglt BgL_varz00_55)
	{
		{	/* Callcc/walk.scm 115 */
			{	/* Callcc/walk.scm 116 */
				bool_t BgL__ortest_1150z00_1516;

				{	/* Callcc/walk.scm 116 */
					bool_t BgL_res1874z00_2033;

					BgL_res1874z00_2033 =
						BGl_isazf3zf3zz__objectz00(
						((obj_t) BgL_varz00_55), BGl_localzf2cellzf2zzcallcc_walkz00);
					BgL__ortest_1150z00_1516 = BgL_res1874z00_2033;
				}
				if (BgL__ortest_1150z00_1516)
					{	/* Callcc/walk.scm 116 */
						return BgL__ortest_1150z00_1516;
					}
				else
					{	/* Callcc/walk.scm 116 */
						if (
							((((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_localz00_bglt) BgL_varz00_55))))->
									BgL_accessz00) == CNST_TABLE_REF(((long) 2))))
							{	/* Callcc/walk.scm 118 */
								bool_t BgL__ortest_1152z00_1518;

								{	/* Callcc/walk.scm 118 */
									BgL_typez00_bglt BgL_arg1628z00_1520;

									BgL_arg1628z00_1520 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_varz00_55))))->BgL_typez00);
									BgL__ortest_1152z00_1518 =
										(
										((obj_t) BgL_arg1628z00_1520) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL__ortest_1152z00_1518)
									{	/* Callcc/walk.scm 118 */
										return BgL__ortest_1152z00_1518;
									}
								else
									{	/* Callcc/walk.scm 119 */
										BgL_typez00_bglt BgL_arg1626z00_1519;

										BgL_arg1626z00_1519 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_localz00_bglt) BgL_varz00_55))))->
											BgL_typez00);
										return
											BGl_bigloozd2typezf3z21zztype_typez00
											(BgL_arg1626z00_1519);
									}
							}
						else
							{	/* Callcc/walk.scm 117 */
								return ((bool_t) 0);
							}
					}
			}
		}

	}



/* callcc*! */
	obj_t BGl_callccza2z12zb0zzcallcc_walkz00(obj_t BgL_nodeza2za2_78)
	{
		{	/* Callcc/walk.scm 358 */
		BGl_callccza2z12zb0zzcallcc_walkz00:
			if (NULLP(BgL_nodeza2za2_78))
				{	/* Callcc/walk.scm 359 */
					return CNST_TABLE_REF(((long) 3));
				}
			else
				{	/* Callcc/walk.scm 359 */
					{	/* Callcc/walk.scm 362 */
						BgL_nodez00_bglt BgL_arg1633z00_1523;

						{	/* Callcc/walk.scm 362 */
							obj_t BgL_arg1636z00_1524;

							BgL_arg1636z00_1524 = CAR(((obj_t) BgL_nodeza2za2_78));
							BgL_arg1633z00_1523 =
								BGl_callccz12z12zzcallcc_walkz00(
								((BgL_nodez00_bglt) BgL_arg1636z00_1524));
						}
						{	/* Callcc/walk.scm 362 */
							obj_t BgL_auxz00_2788;
							obj_t BgL_tmpz00_2786;

							BgL_auxz00_2788 = ((obj_t) BgL_arg1633z00_1523);
							BgL_tmpz00_2786 = ((obj_t) BgL_nodeza2za2_78);
							SET_CAR(BgL_tmpz00_2786, BgL_auxz00_2788);
						}
					}
					{	/* Callcc/walk.scm 363 */
						obj_t BgL_arg1637z00_1525;

						BgL_arg1637z00_1525 = CDR(((obj_t) BgL_nodeza2za2_78));
						{
							obj_t BgL_nodeza2za2_2793;

							BgL_nodeza2za2_2793 = BgL_arg1637z00_1525;
							BgL_nodeza2za2_78 = BgL_nodeza2za2_2793;
							goto BGl_callccza2z12zb0zzcallcc_walkz00;
						}
					}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			{	/* Callcc/walk.scm 25 */
				obj_t BgL_arg1649z00_1530;
				obj_t BgL_arg1651z00_1531;

				{	/* Callcc/walk.scm 25 */
					obj_t BgL_v1309z00_1563;

					BgL_v1309z00_1563 = create_vector(((long) 0));
					BgL_arg1649z00_1530 = BgL_v1309z00_1563;
				}
				{	/* Callcc/walk.scm 25 */
					obj_t BgL_v1310z00_1564;

					BgL_v1310z00_1564 = create_vector(((long) 0));
					BgL_arg1651z00_1531 = BgL_v1310z00_1564;
				}
				return (BGl_localzf2cellzf2zzcallcc_walkz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 4)),
						CNST_TABLE_REF(((long) 5)), BGl_localz00zzast_varz00, ((long) 4868),
						BGl_proc1918z00zzcallcc_walkz00, BGl_proc1917z00zzcallcc_walkz00,
						BFALSE, BGl_proc1916z00zzcallcc_walkz00,
						BGl_proc1915z00zzcallcc_walkz00, BgL_arg1649z00_1530,
						BgL_arg1651z00_1531), BUNSPEC);
		}}

	}



/* &lambda1660 */
	BgL_localz00_bglt BGl_z62lambda1660z62zzcallcc_walkz00(obj_t BgL_envz00_2205,
		obj_t BgL_o1116z00_2206)
	{
		{	/* Callcc/walk.scm 25 */
			{	/* Callcc/walk.scm 25 */
				long BgL_arg1661z00_2305;

				{	/* Callcc/walk.scm 25 */
					obj_t BgL_arg1664z00_2306;

					{	/* Callcc/walk.scm 25 */
						obj_t BgL_arg1665z00_2307;

						{	/* Callcc/walk.scm 25 */
							long BgL_arg1745z00_2308;

							{	/* Callcc/walk.scm 25 */
								long BgL_arg1746z00_2309;

								{	/* Callcc/walk.scm 25 */
									long BgL_res1879z00_2310;

									BgL_res1879z00_2310 =
										BGL_OBJECT_CLASS_NUM(
										((BgL_objectz00_bglt)
											((BgL_localz00_bglt) BgL_o1116z00_2206)));
									BgL_arg1746z00_2309 = BgL_res1879z00_2310;
								}
								BgL_arg1745z00_2308 = (BgL_arg1746z00_2309 - OBJECT_TYPE);
							}
							BgL_arg1665z00_2307 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1745z00_2308);
						}
						BgL_arg1664z00_2306 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1665z00_2307);
					}
					{	/* Callcc/walk.scm 25 */
						long BgL_res1881z00_2311;

						{	/* Callcc/walk.scm 25 */
							obj_t BgL_tmpz00_2805;

							BgL_tmpz00_2805 = ((obj_t) BgL_arg1664z00_2306);
							BgL_res1881z00_2311 = BGL_CLASS_INDEX(BgL_tmpz00_2805);
						}
						BgL_arg1661z00_2305 = BgL_res1881z00_2311;
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_localz00_bglt) BgL_o1116z00_2206)), BgL_arg1661z00_2305);
			}
			{	/* Callcc/walk.scm 25 */
				BgL_objectz00_bglt BgL_tmpz00_2811;

				BgL_tmpz00_2811 =
					((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1116z00_2206));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2811, BFALSE);
			}
			((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1116z00_2206));
			return ((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1116z00_2206));
		}

	}



/* &<@anonymous:1659> */
	obj_t BGl_z62zc3z04anonymousza31659ze3ze5zzcallcc_walkz00(obj_t
		BgL_envz00_2207, obj_t BgL_new1115z00_2208)
	{
		{	/* Callcc/walk.scm 25 */
			{
				BgL_localz00_bglt BgL_auxz00_2819;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1115z00_2208))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 6))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_2827;

					{	/* Callcc/walk.scm 25 */
						obj_t BgL_classz00_2313;

						BgL_classz00_2313 = BGl_typez00zztype_typez00;
						{	/* Callcc/walk.scm 25 */
							obj_t BgL__ortest_1106z00_2314;

							BgL__ortest_1106z00_2314 = BGL_CLASS_NIL(BgL_classz00_2313);
							if (CBOOL(BgL__ortest_1106z00_2314))
								{	/* Callcc/walk.scm 25 */
									BgL_auxz00_2827 =
										((BgL_typez00_bglt) BgL__ortest_1106z00_2314);
								}
							else
								{	/* Callcc/walk.scm 25 */
									BgL_auxz00_2827 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2313));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1115z00_2208))))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_2827), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_2837;

					{	/* Callcc/walk.scm 25 */
						obj_t BgL_classz00_2315;

						BgL_classz00_2315 = BGl_valuez00zzast_varz00;
						{	/* Callcc/walk.scm 25 */
							obj_t BgL__ortest_1106z00_2316;

							BgL__ortest_1106z00_2316 = BGL_CLASS_NIL(BgL_classz00_2315);
							if (CBOOL(BgL__ortest_1106z00_2316))
								{	/* Callcc/walk.scm 25 */
									BgL_auxz00_2837 =
										((BgL_valuez00_bglt) BgL__ortest_1106z00_2316);
								}
							else
								{	/* Callcc/walk.scm 25 */
									BgL_auxz00_2837 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2315));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_localz00_bglt) BgL_new1115z00_2208))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_2837), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_localz00_bglt) BgL_new1115z00_2208))))->BgL_accessz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt) ((BgL_localz00_bglt)
										BgL_new1115z00_2208))))->BgL_keyz00) =
					((long) ((long) 0)), BUNSPEC);
				BgL_auxz00_2819 = ((BgL_localz00_bglt) BgL_new1115z00_2208);
				return ((obj_t) BgL_auxz00_2819);
			}
		}

	}



/* &lambda1656 */
	BgL_localz00_bglt BGl_z62lambda1656z62zzcallcc_walkz00(obj_t BgL_envz00_2209,
		obj_t BgL_o1112z00_2210)
	{
		{	/* Callcc/walk.scm 25 */
			{	/* Callcc/walk.scm 25 */
				BgL_localzf2cellzf2_bglt BgL_wide1114z00_2318;

				BgL_wide1114z00_2318 =
					((BgL_localzf2cellzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_localzf2cellzf2_bgl))));
				{	/* Callcc/walk.scm 25 */
					obj_t BgL_auxz00_2875;
					BgL_objectz00_bglt BgL_tmpz00_2871;

					BgL_auxz00_2875 = ((obj_t) BgL_wide1114z00_2318);
					BgL_tmpz00_2871 =
						((BgL_objectz00_bglt)
						((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1112z00_2210)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2871, BgL_auxz00_2875);
				}
				((BgL_objectz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1112z00_2210)));
				{	/* Callcc/walk.scm 25 */
					long BgL_arg1658z00_2319;

					{	/* Callcc/walk.scm 25 */
						long BgL_res1878z00_2320;

						BgL_res1878z00_2320 =
							BGL_CLASS_INDEX(BGl_localzf2cellzf2zzcallcc_walkz00);
						BgL_arg1658z00_2319 = BgL_res1878z00_2320;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_localz00_bglt)
								((BgL_localz00_bglt) BgL_o1112z00_2210))), BgL_arg1658z00_2319);
				}
				return
					((BgL_localz00_bglt)
					((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1112z00_2210)));
			}
		}

	}



/* &lambda1652 */
	BgL_localz00_bglt BGl_z62lambda1652z62zzcallcc_walkz00(obj_t BgL_envz00_2211,
		obj_t BgL_id1101z00_2212, obj_t BgL_name1102z00_2213,
		obj_t BgL_type1103z00_2214, obj_t BgL_value1104z00_2215,
		obj_t BgL_access1105z00_2216, obj_t BgL_fastzd2alpha1106zd2_2217,
		obj_t BgL_removable1107z00_2218, obj_t BgL_occurrence1108z00_2219,
		obj_t BgL_occurrencew1109z00_2220, obj_t BgL_userzf31110zf3_2221,
		obj_t BgL_key1111z00_2222)
	{
		{	/* Callcc/walk.scm 25 */
			{	/* Callcc/walk.scm 25 */
				long BgL_occurrence1108z00_2324;
				long BgL_occurrencew1109z00_2325;
				bool_t BgL_userzf31110zf3_2326;
				long BgL_key1111z00_2327;

				BgL_occurrence1108z00_2324 = (long) CINT(BgL_occurrence1108z00_2219);
				BgL_occurrencew1109z00_2325 = (long) CINT(BgL_occurrencew1109z00_2220);
				BgL_userzf31110zf3_2326 = CBOOL(BgL_userzf31110zf3_2221);
				BgL_key1111z00_2327 = (long) CINT(BgL_key1111z00_2222);
				{	/* Callcc/walk.scm 25 */
					BgL_localz00_bglt BgL_new1178z00_2328;

					{	/* Callcc/walk.scm 25 */
						BgL_localz00_bglt BgL_tmp1176z00_2329;
						BgL_localzf2cellzf2_bglt BgL_wide1177z00_2330;

						{
							BgL_localz00_bglt BgL_auxz00_2893;

							{	/* Callcc/walk.scm 25 */
								BgL_localz00_bglt BgL_new1175z00_2331;

								BgL_new1175z00_2331 =
									((BgL_localz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_localz00_bgl))));
								{	/* Callcc/walk.scm 25 */
									long BgL_arg1655z00_2332;

									{	/* Callcc/walk.scm 25 */
										long BgL_res1876z00_2333;

										BgL_res1876z00_2333 =
											BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
										BgL_arg1655z00_2332 = BgL_res1876z00_2333;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1175z00_2331),
										BgL_arg1655z00_2332);
								}
								{	/* Callcc/walk.scm 25 */
									BgL_objectz00_bglt BgL_tmpz00_2898;

									BgL_tmpz00_2898 = ((BgL_objectz00_bglt) BgL_new1175z00_2331);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2898, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1175z00_2331);
								BgL_auxz00_2893 = BgL_new1175z00_2331;
							}
							BgL_tmp1176z00_2329 = ((BgL_localz00_bglt) BgL_auxz00_2893);
						}
						BgL_wide1177z00_2330 =
							((BgL_localzf2cellzf2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_localzf2cellzf2_bgl))));
						{	/* Callcc/walk.scm 25 */
							obj_t BgL_auxz00_2906;
							BgL_objectz00_bglt BgL_tmpz00_2904;

							BgL_auxz00_2906 = ((obj_t) BgL_wide1177z00_2330);
							BgL_tmpz00_2904 = ((BgL_objectz00_bglt) BgL_tmp1176z00_2329);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2904, BgL_auxz00_2906);
						}
						((BgL_objectz00_bglt) BgL_tmp1176z00_2329);
						{	/* Callcc/walk.scm 25 */
							long BgL_arg1654z00_2334;

							{	/* Callcc/walk.scm 25 */
								long BgL_res1877z00_2335;

								BgL_res1877z00_2335 =
									BGL_CLASS_INDEX(BGl_localzf2cellzf2zzcallcc_walkz00);
								BgL_arg1654z00_2334 = BgL_res1877z00_2335;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1176z00_2329),
								BgL_arg1654z00_2334);
						}
						BgL_new1178z00_2328 = ((BgL_localz00_bglt) BgL_tmp1176z00_2329);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1178z00_2328)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1101z00_2212)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_namez00) =
						((obj_t) BgL_name1102z00_2213), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1103z00_2214)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1104z00_2215)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_accessz00) =
						((obj_t) BgL_access1105z00_2216), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1106zd2_2217), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_removablez00) =
						((obj_t) BgL_removable1107z00_2218), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_occurrencez00) =
						((long) BgL_occurrence1108z00_2324), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1109z00_2325), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1178z00_2328)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31110zf3_2326), BUNSPEC);
					((((BgL_localz00_bglt) COBJECT(((BgL_localz00_bglt)
										BgL_new1178z00_2328)))->BgL_keyz00) =
						((long) BgL_key1111z00_2327), BUNSPEC);
					return BgL_new1178z00_2328;
				}
			}
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00,
				BGl_proc1919z00zzcallcc_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string1920z00zzcallcc_walkz00);
		}

	}



/* &callcc!1311 */
	obj_t BGl_z62callccz121311z70zzcallcc_walkz00(obj_t BgL_envz00_2224,
		obj_t BgL_nodez00_2225)
	{
		{	/* Callcc/walk.scm 124 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 7)),
				BGl_string1921z00zzcallcc_walkz00,
				((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2225)));
		}

	}



/* callcc! */
	BgL_nodez00_bglt BGl_callccz12z12zzcallcc_walkz00(BgL_nodez00_bglt
		BgL_nodez00_56)
	{
		{	/* Callcc/walk.scm 124 */
			{	/* Callcc/walk.scm 124 */
				obj_t BgL_method1312z00_1573;

				{	/* Callcc/walk.scm 124 */
					obj_t BgL_res1892z00_2111;

					{	/* Callcc/walk.scm 124 */
						long BgL_objzd2classzd2numz00_2076;

						{	/* Callcc/walk.scm 124 */
							long BgL_res1882z00_2079;

							BgL_res1882z00_2079 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_56));
							BgL_objzd2classzd2numz00_2076 = BgL_res1882z00_2079;
						}
						{	/* Callcc/walk.scm 124 */
							obj_t BgL_arg1742z00_2077;

							BgL_arg1742z00_2077 =
								PROCEDURE_REF(BGl_callccz12zd2envzc0zzcallcc_walkz00,
								(int) (((long) 1)));
							{	/* Callcc/walk.scm 124 */
								int BgL_offsetz00_2081;

								BgL_offsetz00_2081 = (int) (BgL_objzd2classzd2numz00_2076);
								{	/* Callcc/walk.scm 124 */
									long BgL_offsetz00_2082;

									BgL_offsetz00_2082 =
										((long) (BgL_offsetz00_2081) - OBJECT_TYPE);
									{	/* Callcc/walk.scm 124 */
										long BgL_modz00_2083;

										BgL_modz00_2083 =
											(BgL_offsetz00_2082 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Callcc/walk.scm 124 */
											long BgL_restz00_2085;

											BgL_restz00_2085 =
												(BgL_offsetz00_2082 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Callcc/walk.scm 124 */

												{	/* Callcc/walk.scm 124 */
													obj_t BgL_bucketz00_2087;

													BgL_bucketz00_2087 =
														VECTOR_REF(
														((obj_t) BgL_arg1742z00_2077), BgL_modz00_2083);
													BgL_res1892z00_2111 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2087), BgL_restz00_2085);
					}}}}}}}}
					BgL_method1312z00_1573 = BgL_res1892z00_2111;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1312z00_1573) (BgL_method1312z00_1573,
						((obj_t) BgL_nodez00_56), BEOA));
			}
		}

	}



/* &callcc! */
	BgL_nodez00_bglt BGl_z62callccz12z70zzcallcc_walkz00(obj_t BgL_envz00_2226,
		obj_t BgL_nodez00_2227)
	{
		{	/* Callcc/walk.scm 124 */
			return
				BGl_callccz12z12zzcallcc_walkz00(((BgL_nodez00_bglt) BgL_nodez00_2227));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_atomz00zzast_nodez00,
				BGl_proc1922z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_kwotez00zzast_nodez00,
				BGl_proc1924z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_varz00zzast_nodez00,
				BGl_proc1925z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc1926z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc1927z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc1928z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc1929z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc1930z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc1931z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc1932z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc1933z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1934z00zzcallcc_walkz00,
				BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc1935z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc1936z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc1937z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc1938z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1939z00zzcallcc_walkz00,
				BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1940z00zzcallcc_walkz00,
				BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc1941z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc1942z00zzcallcc_walkz00, BGl_string1923z00zzcallcc_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_callccz12zd2envzc0zzcallcc_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1943z00zzcallcc_walkz00,
				BGl_string1923z00zzcallcc_walkz00);
		}

	}



/* &callcc!-box-set!1354 */
	BgL_nodez00_bglt BGl_z62callccz12zd2boxzd2setz121354z62zzcallcc_walkz00(obj_t
		BgL_envz00_2249, obj_t BgL_nodez00_2250)
	{
		{	/* Callcc/walk.scm 350 */
			{
				BgL_nodez00_bglt BgL_auxz00_2998;

				{	/* Callcc/walk.scm 352 */
					BgL_nodez00_bglt BgL_arg1783z00_2338;

					BgL_arg1783z00_2338 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2250)))->BgL_valuez00);
					BgL_auxz00_2998 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1783z00_2338);
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2250)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_2998), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2250));
		}

	}



/* &callcc!-box-ref1352 */
	BgL_nodez00_bglt BGl_z62callccz12zd2boxzd2ref1352z70zzcallcc_walkz00(obj_t
		BgL_envz00_2251, obj_t BgL_nodez00_2252)
	{
		{	/* Callcc/walk.scm 344 */
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2252));
		}

	}



/* &callcc!-make-box1350 */
	BgL_nodez00_bglt BGl_z62callccz12zd2makezd2box1350z70zzcallcc_walkz00(obj_t
		BgL_envz00_2253, obj_t BgL_nodez00_2254)
	{
		{	/* Callcc/walk.scm 337 */
			((((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2254)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_callccz12z12zzcallcc_walkz00((((BgL_makezd2boxzd2_bglt)
								COBJECT(((BgL_makezd2boxzd2_bglt) BgL_nodez00_2254)))->
							BgL_valuez00))), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2254));
		}

	}



/* &callcc!-jump-ex-it1348 */
	BgL_nodez00_bglt
		BGl_z62callccz12zd2jumpzd2exzd2it1348za2zzcallcc_walkz00(obj_t
		BgL_envz00_2255, obj_t BgL_nodez00_2256)
	{
		{	/* Callcc/walk.scm 328 */
			{
				BgL_nodez00_bglt BgL_auxz00_3015;

				{	/* Callcc/walk.scm 330 */
					BgL_nodez00_bglt BgL_arg1777z00_2342;

					BgL_arg1777z00_2342 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2256)))->BgL_exitz00);
					BgL_auxz00_3015 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1777z00_2342);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2256)))->
						BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3015), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3021;

				{	/* Callcc/walk.scm 331 */
					BgL_nodez00_bglt BgL_arg1780z00_2343;

					BgL_arg1780z00_2343 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2256)))->
						BgL_valuez00);
					BgL_auxz00_3021 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1780z00_2343);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2256)))->
						BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3021), BUNSPEC);
			}
			return
				((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2256));
		}

	}



/* &callcc!-set-ex-it1346 */
	BgL_nodez00_bglt BGl_z62callccz12zd2setzd2exzd2it1346za2zzcallcc_walkz00(obj_t
		BgL_envz00_2257, obj_t BgL_nodez00_2258)
	{
		{	/* Callcc/walk.scm 321 */
			((((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2258)))->BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_callccz12z12zzcallcc_walkz00((((BgL_setzd2exzd2itz00_bglt)
								COBJECT(((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2258)))->
							BgL_bodyz00))), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt)
					BgL_nodez00_2258));
		}

	}



/* &callcc!-let-var1344 */
	BgL_nodez00_bglt BGl_z62callccz12zd2letzd2var1344z70zzcallcc_walkz00(obj_t
		BgL_envz00_2259, obj_t BgL_nodez00_2260)
	{
		{	/* Callcc/walk.scm 303 */
			{
				BgL_nodez00_bglt BgL_auxz00_3036;

				{	/* Callcc/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg1765z00_2346;

					BgL_arg1765z00_2346 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2260)))->BgL_bodyz00);
					BgL_auxz00_3036 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1765z00_2346);
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2260)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3036), BUNSPEC);
			}
			{	/* Callcc/walk.scm 306 */
				obj_t BgL_g1308z00_2347;

				BgL_g1308z00_2347 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2260)))->BgL_bindingsz00);
				{
					obj_t BgL_l1306z00_2349;

					BgL_l1306z00_2349 = BgL_g1308z00_2347;
				BgL_zc3z04anonymousza31766ze3z87_2348:
					if (PAIRP(BgL_l1306z00_2349))
						{	/* Callcc/walk.scm 306 */
							{	/* Callcc/walk.scm 307 */
								obj_t BgL_bindingz00_2350;

								BgL_bindingz00_2350 = CAR(BgL_l1306z00_2349);
								{	/* Callcc/walk.scm 307 */
									obj_t BgL_varz00_2351;
									obj_t BgL_valz00_2352;

									BgL_varz00_2351 = CAR(((obj_t) BgL_bindingz00_2350));
									BgL_valz00_2352 = CDR(((obj_t) BgL_bindingz00_2350));
									{	/* Callcc/walk.scm 309 */
										BgL_nodez00_bglt BgL_arg1768z00_2353;

										BgL_arg1768z00_2353 =
											BGl_callccz12z12zzcallcc_walkz00(
											((BgL_nodez00_bglt) BgL_valz00_2352));
										{	/* Callcc/walk.scm 309 */
											obj_t BgL_auxz00_3055;
											obj_t BgL_tmpz00_3053;

											BgL_auxz00_3055 = ((obj_t) BgL_arg1768z00_2353);
											BgL_tmpz00_3053 = ((obj_t) BgL_bindingz00_2350);
											SET_CDR(BgL_tmpz00_3053, BgL_auxz00_3055);
										}
									}
									if (BGl_celledzf3zf3zzcallcc_walkz00(
											((BgL_variablez00_bglt) BgL_varz00_2351)))
										{	/* Callcc/walk.scm 310 */
											{	/* Callcc/walk.scm 313 */
												BgL_makezd2boxzd2_bglt BgL_arg1770z00_2354;

												{	/* Callcc/walk.scm 313 */
													obj_t BgL_arg1771z00_2355;

													BgL_arg1771z00_2355 =
														CDR(((obj_t) BgL_bindingz00_2350));
													BgL_arg1770z00_2354 =
														BGl_azd2makezd2cellz00zzcallcc_walkz00(
														((BgL_nodez00_bglt) BgL_arg1771z00_2355),
														((BgL_variablez00_bglt) BgL_varz00_2351));
												}
												{	/* Callcc/walk.scm 312 */
													obj_t BgL_auxz00_3068;
													obj_t BgL_tmpz00_3066;

													BgL_auxz00_3068 = ((obj_t) BgL_arg1770z00_2354);
													BgL_tmpz00_3066 = ((obj_t) BgL_bindingz00_2350);
													SET_CDR(BgL_tmpz00_3066, BgL_auxz00_3068);
												}
											}
											{	/* Callcc/walk.scm 314 */
												BgL_typez00_bglt BgL_vz00_2356;

												BgL_vz00_2356 =
													((BgL_typez00_bglt) BGl_za2cellza2z00zztype_cachez00);
												((((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_localz00_bglt) BgL_varz00_2351))))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_vz00_2356), BUNSPEC);
											}
										}
									else
										{	/* Callcc/walk.scm 310 */
											BFALSE;
										}
								}
							}
							{
								obj_t BgL_l1306z00_3075;

								BgL_l1306z00_3075 = CDR(BgL_l1306z00_2349);
								BgL_l1306z00_2349 = BgL_l1306z00_3075;
								goto BgL_zc3z04anonymousza31766ze3z87_2348;
							}
						}
					else
						{	/* Callcc/walk.scm 306 */
							((bool_t) 1);
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nodez00_2260));
		}

	}



/* &callcc!-let-fun1342 */
	BgL_nodez00_bglt BGl_z62callccz12zd2letzd2fun1342z70zzcallcc_walkz00(obj_t
		BgL_envz00_2261, obj_t BgL_nodez00_2262)
	{
		{	/* Callcc/walk.scm 294 */
			{	/* Callcc/walk.scm 296 */
				obj_t BgL_g1305z00_2358;

				BgL_g1305z00_2358 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2262)))->BgL_localsz00);
				{
					obj_t BgL_l1303z00_2360;

					BgL_l1303z00_2360 = BgL_g1305z00_2358;
				BgL_zc3z04anonymousza31760ze3z87_2359:
					if (PAIRP(BgL_l1303z00_2360))
						{	/* Callcc/walk.scm 296 */
							BGl_callcczd2funz12zc0zzcallcc_walkz00(CAR(BgL_l1303z00_2360));
							{
								obj_t BgL_l1303z00_3085;

								BgL_l1303z00_3085 = CDR(BgL_l1303z00_2360);
								BgL_l1303z00_2360 = BgL_l1303z00_3085;
								goto BgL_zc3z04anonymousza31760ze3z87_2359;
							}
						}
					else
						{	/* Callcc/walk.scm 296 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3087;

				{	/* Callcc/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg1764z00_2361;

					BgL_arg1764z00_2361 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2262)))->BgL_bodyz00);
					BgL_auxz00_3087 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1764z00_2361);
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2262)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3087), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2262));
		}

	}



/* &callcc!-switch1340 */
	BgL_nodez00_bglt BGl_z62callccz12zd2switch1340za2zzcallcc_walkz00(obj_t
		BgL_envz00_2263, obj_t BgL_nodez00_2264)
	{
		{	/* Callcc/walk.scm 283 */
			{
				BgL_nodez00_bglt BgL_auxz00_3095;

				{	/* Callcc/walk.scm 285 */
					BgL_nodez00_bglt BgL_arg1754z00_2363;

					BgL_arg1754z00_2363 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2264)))->BgL_testz00);
					BgL_auxz00_3095 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1754z00_2363);
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2264)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3095), BUNSPEC);
			}
			{	/* Callcc/walk.scm 286 */
				obj_t BgL_g1302z00_2364;

				BgL_g1302z00_2364 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2264)))->BgL_clausesz00);
				{
					obj_t BgL_l1300z00_2366;

					BgL_l1300z00_2366 = BgL_g1302z00_2364;
				BgL_zc3z04anonymousza31755ze3z87_2365:
					if (PAIRP(BgL_l1300z00_2366))
						{	/* Callcc/walk.scm 286 */
							{	/* Callcc/walk.scm 287 */
								obj_t BgL_clausez00_2367;

								BgL_clausez00_2367 = CAR(BgL_l1300z00_2366);
								{	/* Callcc/walk.scm 287 */
									BgL_nodez00_bglt BgL_arg1757z00_2368;

									{	/* Callcc/walk.scm 287 */
										obj_t BgL_arg1758z00_2369;

										BgL_arg1758z00_2369 = CDR(((obj_t) BgL_clausez00_2367));
										BgL_arg1757z00_2368 =
											BGl_callccz12z12zzcallcc_walkz00(
											((BgL_nodez00_bglt) BgL_arg1758z00_2369));
									}
									{	/* Callcc/walk.scm 287 */
										obj_t BgL_auxz00_3112;
										obj_t BgL_tmpz00_3110;

										BgL_auxz00_3112 = ((obj_t) BgL_arg1757z00_2368);
										BgL_tmpz00_3110 = ((obj_t) BgL_clausez00_2367);
										SET_CDR(BgL_tmpz00_3110, BgL_auxz00_3112);
									}
								}
							}
							{
								obj_t BgL_l1300z00_3115;

								BgL_l1300z00_3115 = CDR(BgL_l1300z00_2366);
								BgL_l1300z00_2366 = BgL_l1300z00_3115;
								goto BgL_zc3z04anonymousza31755ze3z87_2365;
							}
						}
					else
						{	/* Callcc/walk.scm 286 */
							((bool_t) 1);
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nodez00_2264));
		}

	}



/* &callcc!-fail1338 */
	BgL_nodez00_bglt BGl_z62callccz12zd2fail1338za2zzcallcc_walkz00(obj_t
		BgL_envz00_2265, obj_t BgL_nodez00_2266)
	{
		{	/* Callcc/walk.scm 273 */
			{
				BgL_nodez00_bglt BgL_auxz00_3119;

				{	/* Callcc/walk.scm 275 */
					BgL_nodez00_bglt BgL_arg1751z00_2371;

					BgL_arg1751z00_2371 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2266)))->BgL_procz00);
					BgL_auxz00_3119 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1751z00_2371);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2266)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3119), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3125;

				{	/* Callcc/walk.scm 276 */
					BgL_nodez00_bglt BgL_arg1752z00_2372;

					BgL_arg1752z00_2372 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2266)))->BgL_msgz00);
					BgL_auxz00_3125 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1752z00_2372);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2266)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3125), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3131;

				{	/* Callcc/walk.scm 277 */
					BgL_nodez00_bglt BgL_arg1753z00_2373;

					BgL_arg1753z00_2373 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2266)))->BgL_objz00);
					BgL_auxz00_3131 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1753z00_2373);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2266)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3131), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nodez00_2266));
		}

	}



/* &callcc!-conditional1336 */
	BgL_nodez00_bglt BGl_z62callccz12zd2conditional1336za2zzcallcc_walkz00(obj_t
		BgL_envz00_2267, obj_t BgL_nodez00_2268)
	{
		{	/* Callcc/walk.scm 263 */
			{
				BgL_nodez00_bglt BgL_auxz00_3139;

				{	/* Callcc/walk.scm 265 */
					BgL_nodez00_bglt BgL_arg1738z00_2375;

					BgL_arg1738z00_2375 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2268)))->BgL_testz00);
					BgL_auxz00_3139 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1738z00_2375);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2268)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3139), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3145;

				{	/* Callcc/walk.scm 266 */
					BgL_nodez00_bglt BgL_arg1749z00_2376;

					BgL_arg1749z00_2376 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2268)))->BgL_truez00);
					BgL_auxz00_3145 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1749z00_2376);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2268)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3145), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3151;

				{	/* Callcc/walk.scm 267 */
					BgL_nodez00_bglt BgL_arg1750z00_2377;

					BgL_arg1750z00_2377 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2268)))->BgL_falsez00);
					BgL_auxz00_3151 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1750z00_2377);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2268)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3151), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nodez00_2268));
		}

	}



/* &callcc!-setq1334 */
	BgL_nodez00_bglt BGl_z62callccz12zd2setq1334za2zzcallcc_walkz00(obj_t
		BgL_envz00_2269, obj_t BgL_nodez00_2270)
	{
		{	/* Callcc/walk.scm 228 */
			((((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2270)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_callccz12z12zzcallcc_walkz00((((BgL_setqz00_bglt)
								COBJECT(((BgL_setqz00_bglt) BgL_nodez00_2270)))->
							BgL_valuez00))), BUNSPEC);
			{	/* Callcc/walk.scm 230 */
				BgL_variablez00_bglt BgL_varz00_2379;

				BgL_varz00_2379 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_setqz00_bglt) COBJECT(
										((BgL_setqz00_bglt) BgL_nodez00_2270)))->BgL_varz00)))->
					BgL_variablez00);
				{	/* Callcc/walk.scm 230 */
					BgL_typez00_bglt BgL_vtypez00_2380;

					BgL_vtypez00_2380 =
						(((BgL_variablez00_bglt) COBJECT(BgL_varz00_2379))->BgL_typez00);
					{	/* Callcc/walk.scm 231 */

						{	/* Callcc/walk.scm 232 */
							obj_t BgL_g1161z00_2381;

							BgL_g1161z00_2381 =
								(((BgL_variablez00_bglt) COBJECT(BgL_varz00_2379))->
								BgL_fastzd2alphazd2);
							{
								BgL_variablez00_bglt BgL_varz00_2383;
								obj_t BgL_alphaz00_2384;

								BgL_varz00_2383 = BgL_varz00_2379;
								BgL_alphaz00_2384 = BgL_g1161z00_2381;
							BgL_loopz00_2382:
								if (BGl_isazf3zf3zz__objectz00(BgL_alphaz00_2384,
										BGl_localz00zzast_varz00))
									{	/* Callcc/walk.scm 234 */
										{	/* Callcc/walk.scm 236 */
											BgL_varz00_bglt BgL_arg1706z00_2385;

											BgL_arg1706z00_2385 =
												(((BgL_setqz00_bglt) COBJECT(
														((BgL_setqz00_bglt) BgL_nodez00_2270)))->
												BgL_varz00);
											((((BgL_varz00_bglt) COBJECT(BgL_arg1706z00_2385))->
													BgL_variablez00) =
												((BgL_variablez00_bglt) ((BgL_variablez00_bglt) (
															(BgL_localz00_bglt) BgL_alphaz00_2384))),
												BUNSPEC);
										}
										{	/* Callcc/walk.scm 237 */
											obj_t BgL_arg1708z00_2386;

											BgL_arg1708z00_2386 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt) BgL_alphaz00_2384))))->
												BgL_fastzd2alphazd2);
											{
												obj_t BgL_alphaz00_3182;
												BgL_variablez00_bglt BgL_varz00_3179;

												BgL_varz00_3179 =
													((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_alphaz00_2384));
												BgL_alphaz00_3182 = BgL_arg1708z00_2386;
												BgL_alphaz00_2384 = BgL_alphaz00_3182;
												BgL_varz00_2383 = BgL_varz00_3179;
												goto BgL_loopz00_2382;
											}
										}
									}
								else
									{	/* Callcc/walk.scm 239 */
										bool_t BgL_test2022z00_3183;

										{	/* Callcc/walk.scm 239 */
											bool_t BgL_res1898z00_2387;

											BgL_res1898z00_2387 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_varz00_2383), BGl_globalz00zzast_varz00);
											BgL_test2022z00_3183 = BgL_res1898z00_2387;
										}
										if (BgL_test2022z00_3183)
											{	/* Callcc/walk.scm 239 */
												return
													((BgL_nodez00_bglt)
													((BgL_setqz00_bglt) BgL_nodez00_2270));
											}
										else
											{	/* Callcc/walk.scm 239 */
												if (BGl_celledzf3zf3zzcallcc_walkz00(BgL_varz00_2383))
													{	/* Callcc/walk.scm 244 */
														BgL_localz00_bglt BgL_azd2varzd2_2388;
														obj_t BgL_locz00_2389;

														BgL_azd2varzd2_2388 =
															BGl_makezd2localzd2svarz00zzast_localz00
															(CNST_TABLE_REF(((long) 8)),
															((BgL_typez00_bglt)
																BGl_za2objza2z00zztype_cachez00));
														BgL_locz00_2389 =
															(((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt) ((BgL_setqz00_bglt)
																			BgL_nodez00_2270))))->BgL_locz00);
														{	/* Callcc/walk.scm 246 */
															BgL_letzd2varzd2_bglt BgL_new1163z00_2390;

															{	/* Callcc/walk.scm 248 */
																BgL_letzd2varzd2_bglt BgL_new1162z00_2391;

																BgL_new1162z00_2391 =
																	((BgL_letzd2varzd2_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_letzd2varzd2_bgl))));
																{	/* Callcc/walk.scm 248 */
																	long BgL_arg1725z00_2392;

																	{	/* Callcc/walk.scm 248 */
																		long BgL_res1899z00_2393;

																		BgL_res1899z00_2393 =
																			BGL_CLASS_INDEX
																			(BGl_letzd2varzd2zzast_nodez00);
																		BgL_arg1725z00_2392 = BgL_res1899z00_2393;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1162z00_2391),
																		BgL_arg1725z00_2392);
																}
																{	/* Callcc/walk.scm 248 */
																	BgL_objectz00_bglt BgL_tmpz00_3200;

																	BgL_tmpz00_3200 =
																		((BgL_objectz00_bglt) BgL_new1162z00_2391);
																	BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3200,
																		BFALSE);
																}
																((BgL_objectz00_bglt) BgL_new1162z00_2391);
																BgL_new1163z00_2390 = BgL_new1162z00_2391;
															}
															((((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				BgL_new1163z00_2390)))->BgL_locz00) =
																((obj_t) BgL_locz00_2389), BUNSPEC);
															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																				BgL_new1163z00_2390)))->BgL_typez00) =
																((BgL_typez00_bglt) ((BgL_typez00_bglt)
																		BGl_za2unspecza2z00zztype_cachez00)),
																BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1163z00_2390)))->
																	BgL_sidezd2effectzd2) =
																((obj_t) BUNSPEC), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1163z00_2390)))->BgL_keyz00) =
																((obj_t) BINT(((long) -1))), BUNSPEC);
															{
																obj_t BgL_auxz00_3214;

																{	/* Callcc/walk.scm 249 */
																	obj_t BgL_arg1712z00_2394;

																	{	/* Callcc/walk.scm 249 */
																		BgL_nodez00_bglt BgL_arg1715z00_2395;

																		BgL_arg1715z00_2395 =
																			(((BgL_setqz00_bglt) COBJECT(
																					((BgL_setqz00_bglt)
																						BgL_nodez00_2270)))->BgL_valuez00);
																		BgL_arg1712z00_2394 =
																			MAKE_YOUNG_PAIR(((obj_t)
																				BgL_azd2varzd2_2388),
																			((obj_t) BgL_arg1715z00_2395));
																	}
																	{	/* Callcc/walk.scm 249 */
																		obj_t BgL_list1713z00_2396;

																		BgL_list1713z00_2396 =
																			MAKE_YOUNG_PAIR(BgL_arg1712z00_2394,
																			BNIL);
																		BgL_auxz00_3214 = BgL_list1713z00_2396;
																}}
																((((BgL_letzd2varzd2_bglt)
																			COBJECT(BgL_new1163z00_2390))->
																		BgL_bindingsz00) =
																	((obj_t) BgL_auxz00_3214), BUNSPEC);
															}
															{
																BgL_nodez00_bglt BgL_auxz00_3222;

																{	/* Callcc/walk.scm 250 */
																	BgL_boxzd2setz12zc0_bglt BgL_new1165z00_2397;

																	{	/* Callcc/walk.scm 253 */
																		BgL_boxzd2setz12zc0_bglt
																			BgL_new1164z00_2398;
																		BgL_new1164z00_2398 =
																			((BgL_boxzd2setz12zc0_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_boxzd2setz12zc0_bgl))));
																		{	/* Callcc/walk.scm 253 */
																			long BgL_arg1719z00_2399;

																			{	/* Callcc/walk.scm 253 */
																				long BgL_res1901z00_2400;

																				{	/* Callcc/walk.scm 253 */
																					obj_t BgL_classz00_2401;

																					BgL_classz00_2401 =
																						BGl_boxzd2setz12zc0zzast_nodez00;
																					BgL_res1901z00_2400 =
																						BGL_CLASS_INDEX(BgL_classz00_2401);
																				}
																				BgL_arg1719z00_2399 =
																					BgL_res1901z00_2400;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1164z00_2398),
																				BgL_arg1719z00_2399);
																		}
																		{	/* Callcc/walk.scm 253 */
																			BgL_objectz00_bglt BgL_tmpz00_3227;

																			BgL_tmpz00_3227 =
																				((BgL_objectz00_bglt)
																				BgL_new1164z00_2398);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3227,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1164z00_2398);
																		BgL_new1165z00_2397 = BgL_new1164z00_2398;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1165z00_2397)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_2389), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1165z00_2397)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2unspecza2z00zztype_cachez00)),
																		BUNSPEC);
																	((((BgL_boxzd2setz12zc0_bglt)
																				COBJECT(BgL_new1165z00_2397))->
																			BgL_varz00) =
																		((BgL_varz00_bglt) (((BgL_setqz00_bglt)
																					COBJECT(((BgL_setqz00_bglt)
																							BgL_nodez00_2270)))->BgL_varz00)),
																		BUNSPEC);
																	{
																		BgL_nodez00_bglt BgL_auxz00_3239;

																		{	/* Callcc/walk.scm 255 */
																			BgL_varz00_bglt BgL_new1167z00_2402;

																			{	/* Callcc/walk.scm 257 */
																				BgL_varz00_bglt BgL_new1166z00_2403;

																				BgL_new1166z00_2403 =
																					((BgL_varz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Callcc/walk.scm 257 */
																					long BgL_arg1716z00_2404;

																					{	/* Callcc/walk.scm 257 */
																						long BgL_res1902z00_2405;

																						{	/* Callcc/walk.scm 257 */
																							obj_t BgL_classz00_2406;

																							BgL_classz00_2406 =
																								BGl_varz00zzast_nodez00;
																							BgL_res1902z00_2405 =
																								BGL_CLASS_INDEX
																								(BgL_classz00_2406);
																						}
																						BgL_arg1716z00_2404 =
																							BgL_res1902z00_2405;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1166z00_2403),
																						BgL_arg1716z00_2404);
																				}
																				BgL_new1167z00_2402 =
																					BgL_new1166z00_2403;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1167z00_2402)))->
																					BgL_locz00) =
																				((obj_t) BgL_locz00_2389), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1167z00_2402)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) ((
																							(BgL_variablez00_bglt)
																							COBJECT(((BgL_variablez00_bglt)
																									BgL_azd2varzd2_2388)))->
																						BgL_typez00)), BUNSPEC);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_new1167z00_2402))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) (
																						(BgL_variablez00_bglt)
																						BgL_azd2varzd2_2388)), BUNSPEC);
																			BgL_auxz00_3239 =
																				((BgL_nodez00_bglt)
																				BgL_new1167z00_2402);
																		}
																		((((BgL_boxzd2setz12zc0_bglt)
																					COBJECT(BgL_new1165z00_2397))->
																				BgL_valuez00) =
																			((BgL_nodez00_bglt) BgL_auxz00_3239),
																			BUNSPEC);
																	}
																	((((BgL_boxzd2setz12zc0_bglt)
																				COBJECT(BgL_new1165z00_2397))->
																			BgL_vtypez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
																			(BgL_vtypez00_2380)), BUNSPEC);
																	BgL_auxz00_3222 =
																		((BgL_nodez00_bglt) BgL_new1165z00_2397);
																}
																((((BgL_letzd2varzd2_bglt)
																			COBJECT(BgL_new1163z00_2390))->
																		BgL_bodyz00) =
																	((BgL_nodez00_bglt) BgL_auxz00_3222),
																	BUNSPEC);
															}
															((((BgL_letzd2varzd2_bglt)
																		COBJECT(BgL_new1163z00_2390))->
																	BgL_removablezf3zf3) =
																((bool_t) ((bool_t) 1)), BUNSPEC);
															return ((BgL_nodez00_bglt) BgL_new1163z00_2390);
														}
													}
												else
													{	/* Callcc/walk.scm 241 */
														return
															((BgL_nodez00_bglt)
															((BgL_setqz00_bglt) BgL_nodez00_2270));
													}
											}
									}
							}
						}
					}
				}
			}
		}

	}



/* &callcc!-cast1332 */
	BgL_nodez00_bglt BGl_z62callccz12zd2cast1332za2zzcallcc_walkz00(obj_t
		BgL_envz00_2271, obj_t BgL_nodez00_2272)
	{
		{	/* Callcc/walk.scm 221 */
			((((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2272)))->BgL_argz00) =
				((BgL_nodez00_bglt)
					BGl_callccz12z12zzcallcc_walkz00((((BgL_castz00_bglt)
								COBJECT(((BgL_castz00_bglt) BgL_nodez00_2272)))->BgL_argz00))),
				BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nodez00_2272));
		}

	}



/* &callcc!-extern1330 */
	BgL_nodez00_bglt BGl_z62callccz12zd2extern1330za2zzcallcc_walkz00(obj_t
		BgL_envz00_2273, obj_t BgL_nodez00_2274)
	{
		{	/* Callcc/walk.scm 214 */
			BGl_callccza2z12zb0zzcallcc_walkz00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2274)))->BgL_exprza2za2));
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2274));
		}

	}



/* &callcc!-funcall1328 */
	BgL_nodez00_bglt BGl_z62callccz12zd2funcall1328za2zzcallcc_walkz00(obj_t
		BgL_envz00_2275, obj_t BgL_nodez00_2276)
	{
		{	/* Callcc/walk.scm 205 */
			{
				BgL_nodez00_bglt BgL_auxz00_3274;

				{	/* Callcc/walk.scm 207 */
					BgL_nodez00_bglt BgL_arg1692z00_2410;

					BgL_arg1692z00_2410 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2276)))->BgL_funz00);
					BgL_auxz00_3274 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1692z00_2410);
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2276)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3274), BUNSPEC);
			}
			BGl_callccza2z12zb0zzcallcc_walkz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2276)))->BgL_argsz00));
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2276));
		}

	}



/* &callcc!-app-ly1326 */
	BgL_nodez00_bglt BGl_z62callccz12zd2appzd2ly1326z70zzcallcc_walkz00(obj_t
		BgL_envz00_2277, obj_t BgL_nodez00_2278)
	{
		{	/* Callcc/walk.scm 196 */
			{
				BgL_nodez00_bglt BgL_auxz00_3285;

				{	/* Callcc/walk.scm 198 */
					BgL_nodez00_bglt BgL_arg1682z00_2412;

					BgL_arg1682z00_2412 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2278)))->BgL_funz00);
					BgL_auxz00_3285 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1682z00_2412);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2278)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3285), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3291;

				{	/* Callcc/walk.scm 199 */
					BgL_nodez00_bglt BgL_arg1689z00_2413;

					BgL_arg1689z00_2413 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2278)))->BgL_argz00);
					BgL_auxz00_3291 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1689z00_2413);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2278)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3291), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2278));
		}

	}



/* &callcc!-app1324 */
	BgL_nodez00_bglt BGl_z62callccz12zd2app1324za2zzcallcc_walkz00(obj_t
		BgL_envz00_2279, obj_t BgL_nodez00_2280)
	{
		{	/* Callcc/walk.scm 188 */
			BGl_callccza2z12zb0zzcallcc_walkz00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2280)))->BgL_argsz00));
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2280));
		}

	}



/* &callcc!-sync1322 */
	BgL_nodez00_bglt BGl_z62callccz12zd2sync1322za2zzcallcc_walkz00(obj_t
		BgL_envz00_2281, obj_t BgL_nodez00_2282)
	{
		{	/* Callcc/walk.scm 178 */
			{
				BgL_nodez00_bglt BgL_auxz00_3304;

				{	/* Callcc/walk.scm 180 */
					BgL_nodez00_bglt BgL_arg1677z00_2416;

					BgL_arg1677z00_2416 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2282)))->BgL_mutexz00);
					BgL_auxz00_3304 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1677z00_2416);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2282)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3304), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3310;

				{	/* Callcc/walk.scm 181 */
					BgL_nodez00_bglt BgL_arg1679z00_2417;

					BgL_arg1679z00_2417 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2282)))->BgL_prelockz00);
					BgL_auxz00_3310 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1679z00_2417);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2282)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3310), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3316;

				{	/* Callcc/walk.scm 182 */
					BgL_nodez00_bglt BgL_arg1680z00_2418;

					BgL_arg1680z00_2418 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2282)))->BgL_bodyz00);
					BgL_auxz00_3316 =
						BGl_callccz12z12zzcallcc_walkz00(BgL_arg1680z00_2418);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2282)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3316), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2282));
		}

	}



/* &callcc!-sequence1320 */
	BgL_nodez00_bglt BGl_z62callccz12zd2sequence1320za2zzcallcc_walkz00(obj_t
		BgL_envz00_2283, obj_t BgL_nodez00_2284)
	{
		{	/* Callcc/walk.scm 171 */
			BGl_callccza2z12zb0zzcallcc_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2284)))->BgL_nodesz00));
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2284));
		}

	}



/* &callcc!-var1318 */
	BgL_nodez00_bglt BGl_z62callccz12zd2var1318za2zzcallcc_walkz00(obj_t
		BgL_envz00_2285, obj_t BgL_nodez00_2286)
	{
		{	/* Callcc/walk.scm 141 */
			{	/* Callcc/walk.scm 142 */
				BgL_variablez00_bglt BgL_varz00_2421;

				BgL_varz00_2421 =
					(((BgL_varz00_bglt) COBJECT(
							((BgL_varz00_bglt) BgL_nodez00_2286)))->BgL_variablez00);
				{	/* Callcc/walk.scm 142 */
					BgL_typez00_bglt BgL_vtypez00_2422;

					BgL_vtypez00_2422 =
						(((BgL_variablez00_bglt) COBJECT(BgL_varz00_2421))->BgL_typez00);
					{	/* Callcc/walk.scm 143 */

						{	/* Callcc/walk.scm 144 */
							obj_t BgL_g1153z00_2423;

							BgL_g1153z00_2423 =
								(((BgL_variablez00_bglt) COBJECT(BgL_varz00_2421))->
								BgL_fastzd2alphazd2);
							{
								BgL_variablez00_bglt BgL_varz00_2425;
								obj_t BgL_alphaz00_2426;

								BgL_varz00_2425 = BgL_varz00_2421;
								BgL_alphaz00_2426 = BgL_g1153z00_2423;
							BgL_loopz00_2424:
								if (BGl_isazf3zf3zz__objectz00(BgL_alphaz00_2426,
										BGl_localz00zzast_varz00))
									{	/* Callcc/walk.scm 146 */
										((((BgL_varz00_bglt) COBJECT(
														((BgL_varz00_bglt) BgL_nodez00_2286)))->
												BgL_variablez00) =
											((BgL_variablez00_bglt) ((BgL_variablez00_bglt) (
														(BgL_localz00_bglt) BgL_alphaz00_2426))), BUNSPEC);
										{	/* Callcc/walk.scm 149 */
											obj_t BgL_arg1669z00_2427;

											BgL_arg1669z00_2427 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt) BgL_alphaz00_2426))))->
												BgL_fastzd2alphazd2);
											{
												obj_t BgL_alphaz00_3345;
												BgL_variablez00_bglt BgL_varz00_3342;

												BgL_varz00_3342 =
													((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_alphaz00_2426));
												BgL_alphaz00_3345 = BgL_arg1669z00_2427;
												BgL_alphaz00_2426 = BgL_alphaz00_3345;
												BgL_varz00_2425 = BgL_varz00_3342;
												goto BgL_loopz00_2424;
											}
										}
									}
								else
									{	/* Callcc/walk.scm 155 */
										bool_t BgL_test2025z00_3346;

										{	/* Callcc/walk.scm 155 */
											bool_t BgL_res1895z00_2428;

											BgL_res1895z00_2428 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_varz00_2425), BGl_globalz00zzast_varz00);
											BgL_test2025z00_3346 = BgL_res1895z00_2428;
										}
										if (BgL_test2025z00_3346)
											{	/* Callcc/walk.scm 155 */
												return
													((BgL_nodez00_bglt)
													((BgL_varz00_bglt) BgL_nodez00_2286));
											}
										else
											{	/* Callcc/walk.scm 155 */
												if (BGl_celledzf3zf3zzcallcc_walkz00(BgL_varz00_2425))
													{	/* Callcc/walk.scm 160 */
														BgL_typez00_bglt BgL_vtypez00_2429;

														BgL_vtypez00_2429 =
															BGl_getzd2bigloozd2definedzd2typezd2zztype_cachez00
															(BgL_vtypez00_2422);
														{	/* Callcc/walk.scm 161 */
															BgL_typez00_bglt BgL_vz00_2430;

															BgL_vz00_2430 =
																((BgL_typez00_bglt)
																BGl_za2cellza2z00zztype_cachez00);
															((((BgL_nodez00_bglt)
																		COBJECT(((BgL_nodez00_bglt) (
																					(BgL_varz00_bglt)
																					BgL_nodez00_2286))))->BgL_typez00) =
																((BgL_typez00_bglt) BgL_vz00_2430), BUNSPEC);
														}
														{	/* Callcc/walk.scm 162 */
															BgL_boxzd2refzd2_bglt BgL_new1156z00_2431;

															{	/* Callcc/walk.scm 165 */
																BgL_boxzd2refzd2_bglt BgL_new1155z00_2432;

																BgL_new1155z00_2432 =
																	((BgL_boxzd2refzd2_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_boxzd2refzd2_bgl))));
																{	/* Callcc/walk.scm 165 */
																	long BgL_arg1674z00_2433;

																	{	/* Callcc/walk.scm 165 */
																		long BgL_res1896z00_2434;

																		BgL_res1896z00_2434 =
																			BGL_CLASS_INDEX
																			(BGl_boxzd2refzd2zzast_nodez00);
																		BgL_arg1674z00_2433 = BgL_res1896z00_2434;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1155z00_2432),
																		BgL_arg1674z00_2433);
																}
																{	/* Callcc/walk.scm 165 */
																	BgL_objectz00_bglt BgL_tmpz00_3362;

																	BgL_tmpz00_3362 =
																		((BgL_objectz00_bglt) BgL_new1155z00_2432);
																	BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3362,
																		BFALSE);
																}
																((BgL_objectz00_bglt) BgL_new1155z00_2432);
																BgL_new1156z00_2431 = BgL_new1155z00_2432;
															}
															((((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				BgL_new1156z00_2431)))->BgL_locz00) =
																((obj_t) (((BgL_nodez00_bglt)
																			COBJECT(((BgL_nodez00_bglt) (
																						(BgL_varz00_bglt)
																						BgL_nodez00_2286))))->BgL_locz00)),
																BUNSPEC);
															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																				BgL_new1156z00_2431)))->BgL_typez00) =
																((BgL_typez00_bglt) BgL_vtypez00_2429),
																BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1156z00_2431)))->
																	BgL_sidezd2effectzd2) =
																((obj_t) BUNSPEC), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1156z00_2431)))->BgL_keyz00) =
																((obj_t) BINT(((long) -1))), BUNSPEC);
															((((BgL_boxzd2refzd2_bglt)
																		COBJECT(BgL_new1156z00_2431))->BgL_varz00) =
																((BgL_varz00_bglt) ((BgL_varz00_bglt)
																		BgL_nodez00_2286)), BUNSPEC);
															((((BgL_boxzd2refzd2_bglt)
																		COBJECT(BgL_new1156z00_2431))->
																	BgL_vtypez00) =
																((BgL_typez00_bglt) BgL_vtypez00_2429),
																BUNSPEC);
															return ((BgL_nodez00_bglt) BgL_new1156z00_2431);
														}
													}
												else
													{	/* Callcc/walk.scm 157 */
														return
															((BgL_nodez00_bglt)
															((BgL_varz00_bglt) BgL_nodez00_2286));
													}
											}
									}
							}
						}
					}
				}
			}
		}

	}



/* &callcc!-kwote1316 */
	BgL_nodez00_bglt BGl_z62callccz12zd2kwote1316za2zzcallcc_walkz00(obj_t
		BgL_envz00_2287, obj_t BgL_nodez00_2288)
	{
		{	/* Callcc/walk.scm 135 */
			return ((BgL_nodez00_bglt) ((BgL_kwotez00_bglt) BgL_nodez00_2288));
		}

	}



/* &callcc!-atom1314 */
	BgL_nodez00_bglt BGl_z62callccz12zd2atom1314za2zzcallcc_walkz00(obj_t
		BgL_envz00_2289, obj_t BgL_nodez00_2290)
	{
		{	/* Callcc/walk.scm 129 */
			return ((BgL_nodez00_bglt) ((BgL_atomz00_bglt) BgL_nodez00_2290));
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcallcc_walkz00()
	{
		{	/* Callcc/walk.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 315247917),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476633989),
				BSTRING_TO_STRING(BGl_string1944z00zzcallcc_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
